import "./alert.css";
import { defineComponent as C, resolveComponent as v, openBlock as o, createBlock as n, Teleport as B, createElementBlock as i, normalizeClass as a, createElementVNode as r, withModifiers as m, resolveDynamicComponent as y, createCommentVNode as s, renderSlot as b, toDisplayString as l, createTextVNode as f, withCtx as k } from "vue";
import $ from "../button/button.js";
import S from "../progress-circular/progress-circular.js";
import { c as q, q as X, w as M, i as N, x as g } from "../../icons-ba8254f6.js";
import { _ as T } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
const V = C({
  emits: {
    close: (e) => !0
  },
  props: {
    backdropBlur: {
      default: !0,
      type: Boolean
    },
    cancelButton: {
      required: !1,
      type: Object
    },
    confirmButton: {
      required: !1,
      type: Object
    },
    customClass: {
      required: !1,
      type: String
    },
    duration: {
      required: !0,
      type: Number
    },
    icon: {
      required: !1,
      type: String
    },
    positionX: {
      default: "right",
      type: String
    },
    positionY: {
      default: "top",
      type: String
    },
    show: {
      required: !0,
      type: Boolean
    },
    text: {
      default: "...",
      type: String
    },
    title: {
      default: "...",
      type: String
    },
    variant: {
      default: "flat",
      type: String
    }
  },
  name: "sb-alert",
  components: {
    "sb-button": $,
    "sb-circular-progress": S
  },
  data() {
    return {
      localShow: !1,
      maskClasses: ["hide"]
    };
  },
  computed: {
    getIcon() {
      switch (this.icon) {
        case "error":
          return g();
        case "info":
          return N();
        case "warning":
          return M();
        case "question":
          return X();
        default:
          return q();
      }
    },
    iconXMark() {
      return g();
    }
  },
  methods: {
    doClose(e) {
      this.icon !== "loading" && this.$emit("close", e);
    },
    handleShow(e) {
      var t, u, d, c;
      e ? (this.localShow = !0, this.maskClasses = ["show"]) : (setTimeout(() => {
        this.localShow = !1;
      }, 100), this.maskClasses = ["hide"]), this.variant === "big" && (e ? (u = (t = document == null ? void 0 : document.querySelector("body")) == null ? void 0 : t.classList) == null || u.add("sb-overflow-hidden") : (c = (d = document == null ? void 0 : document.querySelector("body")) == null ? void 0 : d.classList) == null || c.remove("sb-overflow-hidden")), e && this.duration > 0 && setTimeout(() => {
        this.$emit("close");
      }, this.duration);
    }
  },
  watch: {
    show(e) {
      this.handleShow(e);
    }
  }
});
const Y = {
  key: 0,
  class: "icon-wrapper"
}, j = {
  key: 1,
  class: "icon-wrapper icon-slot"
}, z = { class: "text-wrapper" }, D = {
  key: 0,
  class: "title"
}, E = { class: "text" }, I = {
  key: 1,
  class: "alert-buttons"
}, L = {
  key: 2,
  class: "close-wrapper"
};
function O(e, t, u, d, c, P) {
  const w = v("sb-circular-progress"), h = v("sb-button");
  return o(), n(B, { to: "body" }, [
    e.localShow ? (o(), i("div", {
      key: 0,
      class: a(["alert-mask", [
        ...e.maskClasses,
        `x_${e.positionX}`,
        `y_${e.positionY}`,
        e.variant
      ]])
    }, [
      r("div", {
        class: a(["backdrop", { blur: e.backdropBlur }]),
        onClick: t[0] || (t[0] = m((p) => e.doClose(), ["stop"]))
      }, null, 2),
      r("div", {
        class: a(["alert", [
          e.customClass,
          e.icon,
          e.show ? "show" : "hide",
          `x_${e.positionX}`,
          `y_${e.positionY}`,
          e.variant
        ]])
      }, [
        e.icon && !e.$slots["custom-icon"] ? (o(), i("div", Y, [
          r("div", {
            class: a(["icon", [e.icon]])
          }, [
            e.icon !== "loading" ? (o(), n(y(e.getIcon), { key: 0 })) : e.icon === "loading" && e.variant === "big" ? (o(), n(w, {
              key: 1,
              indeterminate: "",
              color: "accent",
              size: 96
            })) : s("", !0)
          ], 2)
        ])) : s("", !0),
        e.$slots["custom-icon"] ? (o(), i("div", j, [
          b(e.$slots, "custom-icon")
        ])) : s("", !0),
        r("div", z, [
          e.variant === "big" ? (o(), i("div", D, l(e.title), 1)) : s("", !0),
          r("div", E, [
            b(e.$slots, "body", {}, () => [
              f(l(e.text), 1)
            ])
          ]),
          (e.confirmButton || e.cancelButton) && e.variant === "big" ? (o(), i("div", I, [
            e.cancelButton ? (o(), n(h, {
              key: 0,
              "no-elevation": "",
              type: "button",
              color: e.cancelButton.color || "default",
              variant: e.cancelButton.variant || "contained",
              onClick: t[1] || (t[1] = m((p) => e.doClose("cancel"), ["stop"]))
            }, {
              default: k(() => [
                f(l(e.cancelButton.text), 1)
              ]),
              _: 1
            }, 8, ["color", "variant"])) : s("", !0),
            e.confirmButton ? (o(), n(h, {
              key: 1,
              "no-elevation": "",
              type: "button",
              color: e.confirmButton.color || "primary",
              variant: e.confirmButton.variant || "contained",
              onClick: t[2] || (t[2] = m((p) => e.doClose("confirm"), ["stop"]))
            }, {
              default: k(() => [
                f(l(e.confirmButton.text), 1)
              ]),
              _: 1
            }, 8, ["color", "variant"])) : s("", !0)
          ])) : s("", !0)
        ]),
        e.duration < 0 && e.variant !== "big" ? (o(), i("div", L, [
          r("div", {
            class: "x-mark",
            onClick: t[3] || (t[3] = (p) => e.doClose())
          }, [
            (o(), n(y(e.iconXMark)))
          ])
        ])) : s("", !0)
      ], 2)
    ], 2)) : s("", !0)
  ]);
}
const Q = /* @__PURE__ */ T(V, [["render", O]]);
export {
  Q as default
};
