import { PropType } from 'vue';
import { IDTChangeResponse, IDTColumn, IDTLanguage, IDTServerSideHandler, IDTSort, ILengthChange, IPagination, IServerSide } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    canClickRow: {
        required: false;
        type: BooleanConstructor;
    };
    canHoverRow: {
        required: false;
        type: BooleanConstructor;
    };
    columnSearchPlacement: {
        default: string;
        type: PropType<"top" | "bottom">;
    };
    columns: {
        required: false;
        type: PropType<IDTColumn[]>;
    };
    defaultSort: {
        required: false;
        type: PropType<IDTSort>;
    };
    isLoading: {
        required: false;
        type: BooleanConstructor;
    };
    language: {
        required: false;
        type: PropType<IDTLanguage>;
    };
    lengthChange: {
        default: () => {
            enabled: boolean;
            options: number[];
        };
        type: PropType<ILengthChange>;
    };
    list: {
        required: false;
        type: PropType<any[]>;
    };
    onAjax: {
        required: false;
        type: PropType<(_resp: IDTServerSideHandler, _type: 'BEFORE SEND' | 'ERROR' | 'SUCCESS') => void>;
    };
    pagination: {
        required: false;
        type: PropType<IPagination>;
    };
    rowStyle: {
        default: string;
        type: PropType<"default" | "odd-even">;
    };
    search: {
        default: boolean;
        type: BooleanConstructor;
    };
    serverSide: {
        required: false;
        type: PropType<IServerSide>;
    };
}, unknown, {
    colSearchState: any[];
    localAbort: any;
    localLoading: boolean;
    localPagination: {
        current: number;
        length: number;
        total: number;
        totalRow: number;
    };
    response: IDTChangeResponse;
    selectedLength: any;
}, {
    getCounter(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    getLanguageResult(): string | null;
    getLengthOptions(): {
        label: number;
        value: number;
    }[];
    iconAngleLeft(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconAngleRight(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconMagnifyingGlass(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconSortDown(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconSortUp(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconXMark(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    isColSearch(): boolean;
    isColSearchTop(): boolean;
    isColSort(): boolean;
    showColumnSearch(): boolean;
    showFooter(): boolean;
}, {
    /**
     * Trigger Datatable refresh data (only Server Side)
     */
    doRefresh(): void;
    getHeadClass(index: number): any[];
    getModdedResponse(): {
        termColumns: any[];
        sort: {
            column?: string | number | undefined;
            dir?: string | undefined;
        };
        page: number;
        length: number;
        term: string;
    };
    handleAJAX(): Promise<void>;
    handleChange(): void;
    handleClickColSearch(index: number, isClose?: boolean): void;
    handleClickRow(ev: MouseEvent, row: any): void;
    handlePaginate(operation: number, isDisabled: boolean): void;
    handleColSort(column: number): void;
    isTopSearchEnabled(index: number): any;
    setEmptyData(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    change: (_resp: IDTChangeResponse) => boolean;
    clickRow: (_ev: MouseEvent, _data: any) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    canClickRow: {
        required: false;
        type: BooleanConstructor;
    };
    canHoverRow: {
        required: false;
        type: BooleanConstructor;
    };
    columnSearchPlacement: {
        default: string;
        type: PropType<"top" | "bottom">;
    };
    columns: {
        required: false;
        type: PropType<IDTColumn[]>;
    };
    defaultSort: {
        required: false;
        type: PropType<IDTSort>;
    };
    isLoading: {
        required: false;
        type: BooleanConstructor;
    };
    language: {
        required: false;
        type: PropType<IDTLanguage>;
    };
    lengthChange: {
        default: () => {
            enabled: boolean;
            options: number[];
        };
        type: PropType<ILengthChange>;
    };
    list: {
        required: false;
        type: PropType<any[]>;
    };
    onAjax: {
        required: false;
        type: PropType<(_resp: IDTServerSideHandler, _type: 'BEFORE SEND' | 'ERROR' | 'SUCCESS') => void>;
    };
    pagination: {
        required: false;
        type: PropType<IPagination>;
    };
    rowStyle: {
        default: string;
        type: PropType<"default" | "odd-even">;
    };
    search: {
        default: boolean;
        type: BooleanConstructor;
    };
    serverSide: {
        required: false;
        type: PropType<IServerSide>;
    };
}>> & {
    onChange?: ((_resp: IDTChangeResponse) => any) | undefined;
    onClickRow?: ((_ev: MouseEvent, _data: any) => any) | undefined;
}, {
    search: boolean;
    isLoading: boolean;
    lengthChange: ILengthChange;
    canClickRow: boolean;
    canHoverRow: boolean;
    columnSearchPlacement: "top" | "bottom";
    rowStyle: "default" | "odd-even";
}, {}>;
export default _default;
