import "./form-checkbox.css";
import { defineComponent as u, openBlock as t, createElementBlock as r, mergeProps as h, normalizeClass as n, createElementVNode as d, toDisplayString as p, createCommentVNode as a, Fragment as f, renderList as m, createBlock as y, resolveDynamicComponent as b } from "vue";
import { c as g } from "../../icons-ba8254f6.js";
import { _ as k } from "../../_plugin-vue_export-helper-dad06003.js";
const v = u({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0,
    input: (e) => !0
  },
  props: {
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    isError: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    list: {
      required: !0,
      type: Object
    },
    modelValue: {
      required: !1,
      type: Object
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    value: {
      required: !1,
      type: Object
    }
  },
  name: "sb-form-checkbox-input",
  data() {
    return {
      selected: this.modelValue || this.value || null
    };
  },
  computed: {
    check() {
      return g();
    }
  },
  methods: {
    doSelect(e) {
      if (!this.disabled && !this.readOnly) {
        if (this.selected && this.selected.length > 0) {
          const s = this.selected.findIndex(
            (l) => l.value === e.value
          );
          if (s > -1) {
            const l = [
              ...this.selected
            ];
            l.splice(s, 1), this.selected = [...l];
          } else
            this.selected = [...this.selected, e];
        } else
          (!this.selected || this.selected && this.selected.length < 1) && (this.selected = [e]);
        this.$nextTick(() => {
          this.$emit("update:modelValue", this.selected), this.$emit("input", this.selected), this.$emit("change", this.selected);
        });
      }
    },
    handleErrorMessage() {
      return this.errorMessage ? typeof this.errorMessage == "string" ? this.errorMessage : this.errorMessage(this.selected) : "";
    },
    handleKeydown(e, s) {
      e.key === "Enter" && this.doSelect(s);
    },
    isSelected(e) {
      return this.selected && Object.keys(this.selected).length > 0 ? !!this.selected.find(
        (s) => s.value === e.value
      ) : !1;
    }
  },
  watch: {
    modelValue: {
      deep: !0,
      handler(e) {
        e ? this.selected = [...e] : this.selected = null;
      }
    },
    value: {
      deep: !0,
      handler(e) {
        e ? this.selected = [...e] : this.selected = null;
      }
    }
  }
});
const _ = {
  key: 0,
  class: "asterisk"
}, q = ["tabindex", "onClick", "onKeydown"], M = { class: "selector" }, S = ["innerHTML"], $ = {
  key: 1,
  class: "error-wrapper"
}, O = ["innerHTML"];
function C(e, s, l, E, B, w) {
  return t(), r("div", h({
    class: ["checkbox-wrapper", { error: e.isError }]
  }, { ...e.$attrs }), [
    e.label ? (t(), r("label", {
      key: 0,
      class: n(["label", { required: e.required }])
    }, [
      d("span", null, p(e.label), 1),
      e.required ? (t(), r("span", _, "*")) : a("", !0)
    ], 2)) : a("", !0),
    d("div", {
      class: n(["input-group checkboxs-wrapper", { disabled: e.disabled, readonly: e.readOnly }])
    }, [
      (t(!0), r(f, null, m(e.list, (i, c) => (t(), r("div", {
        class: n(["checkbox", {
          disabled: e.disabled,
          readonly: e.readOnly,
          selected: e.isSelected(i)
        }]),
        key: c,
        tabindex: !e.disabled && !e.readOnly ? 0 : -1,
        onClick: (o) => e.doSelect(i),
        onKeydown: (o) => e.handleKeydown(o, i)
      }, [
        d("div", M, [
          (t(), y(b(e.check)))
        ]),
        d("p", {
          class: "label",
          innerHTML: i.label
        }, null, 8, S)
      ], 42, q))), 128))
    ], 2),
    e.isError ? (t(), r("div", $, [
      d("span", {
        innerHTML: e.handleErrorMessage()
      }, null, 8, O)
    ])) : a("", !0)
  ], 16);
}
const j = /* @__PURE__ */ k(v, [["render", C], ["__scopeId", "data-v-d6b99d31"]]);
export {
  j as default
};
