import { PropType } from 'vue';
import DayJS, { Dayjs } from 'dayjs';
import { IDate } from '../../interface';
interface IPopupValue {
    date: number;
    hour: number | number[];
    minute: number | number[];
    month: number;
    year: number;
}
declare const _default: import("vue").DefineComponent<{
    closeOnSelect: {
        required: false;
        type: BooleanConstructor;
    };
    datepickerElem: {
        required: false;
        type: PropType<HTMLElement>;
    };
    inputWrapper: {
        required: false;
        type: ObjectConstructor;
    };
    locale: {
        required: false;
        type: PropType<"id" | "en">;
    };
    max: {
        required: false;
        type: StringConstructor;
    };
    min: {
        required: false;
        type: StringConstructor;
    };
    overrideDateSelectable: {
        required: false;
        type: PropType<(_date: string) => boolean>;
    };
    overrideDateStyle: {
        required: false;
        type: PropType<(_date: IDate) => Record<string, any>>;
    };
    range: {
        required: false;
        type: BooleanConstructor;
    };
    saveText: {
        required: false;
        type: StringConstructor;
    };
    show: {
        required: true;
        type: BooleanConstructor;
    };
    type: {
        default: string;
        required: true;
        type: PropType<"time" | "date" | "datetime" | "month" | "year">;
    };
    value: {
        required: false;
        type: PropType<DayJS.Dayjs | DayJS.Dayjs[]>;
    };
}, unknown, {
    lastHoverDate: DayJS.Dayjs | null;
    localShowContainer: "time" | "calendar" | "year-list" | "month-list" | "hour-list" | "minute-list";
    parentWithScroll: HTMLElement | null;
    popupCurrentValue: IPopupValue;
    popupStyles: any;
    selectedHourIndex: number;
    selectedMinuteIndex: number;
}, {
    getDates(): IDate[];
    getDays(): DayJS.WeekdayNames;
    getFooterIcon(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    getYears(): number[];
    iconAngleDoubleLeft(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconAngleDoubleRight(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconAngleDown(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconAngleLeft(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconAngleRight(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconAngleUp(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    isSaveDisabled(): boolean;
}, {
    getDisplayTimeHour(pos: number): string;
    getDisplayTimeMinute(pos: number): string;
    getMonthText(month: number, isShort?: boolean): string;
    handleClickHour(hour: number): void;
    handleClickMinute(minute: number): void;
    handleClickMonth(month: number): void;
    handleClickYear(year: number): void;
    handleDateMouseover({ disabled, value }: IDate): void;
    handleFooterClick(): void;
    handleLocale(): void;
    handleNavMonth(inc: number): void;
    handleNavTime(inc: number, type: 'hour' | 'minute', pos: number): void;
    handleNavTimeNotRange(inc: number, type: 'hour' | 'minute'): void;
    handleNavTimeRange(inc: number, type: 'hour' | 'minute', pos: number): void;
    handleNavYear(inc: number): void;
    handleOverrideDateStyle(date: IDate): Record<string, any>;
    handleParentScroll(isOpen: boolean): void;
    handleSave(): void;
    handleSelectDate({ disabled, value }: IDate): void;
    handleShowHourList(pos: number): void;
    handleShowMinuteList(pos: number): void;
    handleShowMonthList(): void;
    handleShowYearList(): void;
    isCurrentDate({ value, viewOnly }: IDate): boolean;
    isDateDisabled(date: number): boolean;
    isDateInRange({ value }: IDate): boolean;
    isDateSelected({ value, viewOnly }: IDate): boolean;
    isHourSelected(hour: number): boolean;
    isMinuteSelected(minute: number): boolean;
    isMonthSelected(month: number): boolean;
    isYearSelected(year: number): boolean;
    setModelValueDate(date: number): void;
    setModelValueTime(): void;
    setPopupPosition(): void;
    setPopupValue(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    change: (_selected: Dayjs | Dayjs[]) => boolean;
    changeTime: (_selected: Dayjs[]) => boolean;
    save: () => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    closeOnSelect: {
        required: false;
        type: BooleanConstructor;
    };
    datepickerElem: {
        required: false;
        type: PropType<HTMLElement>;
    };
    inputWrapper: {
        required: false;
        type: ObjectConstructor;
    };
    locale: {
        required: false;
        type: PropType<"id" | "en">;
    };
    max: {
        required: false;
        type: StringConstructor;
    };
    min: {
        required: false;
        type: StringConstructor;
    };
    overrideDateSelectable: {
        required: false;
        type: PropType<(_date: string) => boolean>;
    };
    overrideDateStyle: {
        required: false;
        type: PropType<(_date: IDate) => Record<string, any>>;
    };
    range: {
        required: false;
        type: BooleanConstructor;
    };
    saveText: {
        required: false;
        type: StringConstructor;
    };
    show: {
        required: true;
        type: BooleanConstructor;
    };
    type: {
        default: string;
        required: true;
        type: PropType<"time" | "date" | "datetime" | "month" | "year">;
    };
    value: {
        required: false;
        type: PropType<DayJS.Dayjs | DayJS.Dayjs[]>;
    };
}>> & {
    onChange?: ((_selected: DayJS.Dayjs | DayJS.Dayjs[]) => any) | undefined;
    onChangeTime?: ((_selected: DayJS.Dayjs[]) => any) | undefined;
    onSave?: (() => any) | undefined;
}, {
    type: "time" | "date" | "datetime" | "month" | "year";
    closeOnSelect: boolean;
    range: boolean;
}, {}>;
export default _default;
