import { PropType } from 'vue';
import { Dayjs } from 'dayjs';
import { IDate, IIcon } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    allowClear: {
        required: false;
        type: BooleanConstructor;
    };
    autocomplete: {
        required: false;
        type: BooleanConstructor;
    };
    closeOnSelect: {
        required: false;
        type: BooleanConstructor;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    format: {
        required: false;
        type: StringConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    locale: {
        required: false;
        type: PropType<"id" | "en">;
    };
    max: {
        required: false;
        type: StringConstructor;
    };
    min: {
        required: false;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<string | string[] | null>;
    };
    noIcon: {
        required: false;
        type: BooleanConstructor;
    };
    overrideDateSelectable: {
        required: false;
        type: PropType<(_date: string) => boolean>;
    };
    overrideDateStyle: {
        required: false;
        type: PropType<(_date: IDate) => Record<string, any>>;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    range: {
        required: false;
        type: BooleanConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    saveText: {
        required: false;
        type: StringConstructor;
    };
    type: {
        default: string;
        required: false;
        type: PropType<"time" | "date" | "datetime" | "month" | "year">;
    };
    value: {
        required: false;
        type: PropType<string | string[] | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
}, unknown, {
    datepickerWrapper: any;
    icon: IIcon;
    inputWrapper: any;
    localValue: any;
    localShow: boolean;
    valueString: any;
}, {
    getIcon(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
}, {
    emitFinalValue(): void;
    getDefaultFormat(): "YYYY-MM-DD" | "YYYY-MM-DD HH:mm:ss" | "HH:mm:ss" | "YYYY-MM" | "YYYY";
    handleClickIcon(): void | null;
    handleClickOutsideDatepicker(event: MouseEvent): void;
    handleGenerateString(): void;
    handleKeyDown(ev: Event): void;
    handleLocale(): void;
    handleOnChange(value: any): void;
    handleOnChangeTime(value: Dayjs[]): void;
    handleOnSave(): void;
    handleOpenCalendar(): void;
    handleUpdateModelValue(value: any): void;
    handleRangeUpdateModelValue(): void;
    setLocalValue(value: any): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_selected: string | string[] | null) => boolean;
    change: (_selected: string | string[] | null) => boolean;
    input: (_selected: string | string[] | null) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    allowClear: {
        required: false;
        type: BooleanConstructor;
    };
    autocomplete: {
        required: false;
        type: BooleanConstructor;
    };
    closeOnSelect: {
        required: false;
        type: BooleanConstructor;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    format: {
        required: false;
        type: StringConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    locale: {
        required: false;
        type: PropType<"id" | "en">;
    };
    max: {
        required: false;
        type: StringConstructor;
    };
    min: {
        required: false;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<string | string[] | null>;
    };
    noIcon: {
        required: false;
        type: BooleanConstructor;
    };
    overrideDateSelectable: {
        required: false;
        type: PropType<(_date: string) => boolean>;
    };
    overrideDateStyle: {
        required: false;
        type: PropType<(_date: IDate) => Record<string, any>>;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    range: {
        required: false;
        type: BooleanConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    saveText: {
        required: false;
        type: StringConstructor;
    };
    type: {
        default: string;
        required: false;
        type: PropType<"time" | "date" | "datetime" | "month" | "year">;
    };
    value: {
        required: false;
        type: PropType<string | string[] | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
}>> & {
    onChange?: ((_selected: string | string[] | null) => any) | undefined;
    onInput?: ((_selected: string | string[] | null) => any) | undefined;
    "onUpdate:modelValue"?: ((_selected: string | string[] | null) => any) | undefined;
}, {
    type: "time" | "date" | "datetime" | "month" | "year";
    required: boolean;
    disabled: boolean;
    variant: "default" | "flat";
    isError: boolean;
    autocomplete: boolean;
    readOnly: boolean;
    allowClear: boolean;
    closeOnSelect: boolean;
    range: boolean;
    noIcon: boolean;
}, {}>;
export default _default;
