import { PropType } from 'vue';
import { IIcon, IServerSide, IServerSideHandler } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    allowClear: {
        required: false;
        type: BooleanConstructor;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    closeOnSelect: {
        default: boolean;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    flat: {
        required: false;
        type: BooleanConstructor;
    };
    infinite: {
        required: false;
        type: BooleanConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isLoading: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: false;
        type: PropType<any[]>;
    };
    loadingText: {
        default: string;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<number | String | Record<string, any> | number[] | Record<string, any>[] | String[] | null>;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    noResultText: {
        default: string;
        type: StringConstructor;
    };
    onAjax: {
        required: false;
        type: PropType<(_resp: IServerSideHandler, _type: string | 'BEFORE SEND' | 'ERROR' | 'SUCCESS', _isLoadMore?: boolean) => void>;
    };
    onPopulateList: {
        required: false;
        type: PropType<(_term: string, _isLoadMore?: boolean) => void>;
    };
    optLabel: {
        required: true;
        type: (StringConstructor | FunctionConstructor)[];
    };
    optValue: {
        required: false;
        type: StringConstructor;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    search: {
        required: false;
        type: BooleanConstructor;
    };
    serverSide: {
        required: false;
        type: PropType<IServerSide>;
    };
    value: {
        required: false;
        type: PropType<number | String | Record<string, any> | number[] | Record<string, any>[] | String[] | null>;
    };
}, unknown, {
    activeOption: number;
    elem: any;
    icon: IIcon;
    isFocus: boolean;
    isOpen: boolean;
    localList: any[];
    localLoading: boolean;
    localTerm: string;
    optWrapperStyles: {
        left: string;
        top: string;
        width: string;
    };
    isScrollBottom: boolean;
    parentWithScroll: any;
    selected: any;
    termMulti: any;
    termSingle: any;
}, {
    getIcon(): {
        onClick?: ((_ev: Event) => void) | undefined;
        onMouseOver?: ((_ev: Event) => void) | undefined;
        onMouseLeave?: ((_ev: Event) => void) | undefined;
        placement?: string | undefined;
    };
    getIconSVG(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
}, {
    doSelect(opt: any, isSelected?: boolean): void;
    handleAjax(resp: IServerSideHandler, type: string, isLoadMore?: boolean): void | null;
    handleAjaxLoading(isLoading: boolean): void;
    handleArrowEvent(inc: number, event: KeyboardEvent): void;
    handleClear(index?: number): void;
    handleClickIcon(): void;
    handleFilterList(term: string): void;
    handleKeyEvent(event: KeyboardEvent): void;
    handleListChange(list: any[]): void;
    handleOpen(): void;
    handleOptValue(): void;
    handleParentBlur(event: FocusEvent): void;
    handleParentClickOutside(event: MouseEvent): void;
    handleParentFocus(): void;
    handleParentScroll(isOpen: boolean): void;
    handleRemoveFocus(): void;
    handleUpdateModel(): void;
    onScrollBottom(e: any): void;
    setOptionsPosition(): {
        left: string;
        top: string;
        width: string;
    } | undefined;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_selected: any) => boolean;
    change: (_selected: any) => boolean;
    close: () => boolean;
    input: (_selected: any) => boolean;
    open: () => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    allowClear: {
        required: false;
        type: BooleanConstructor;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    closeOnSelect: {
        default: boolean;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    flat: {
        required: false;
        type: BooleanConstructor;
    };
    infinite: {
        required: false;
        type: BooleanConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isLoading: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: false;
        type: PropType<any[]>;
    };
    loadingText: {
        default: string;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<number | String | Record<string, any> | number[] | Record<string, any>[] | String[] | null>;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    noResultText: {
        default: string;
        type: StringConstructor;
    };
    onAjax: {
        required: false;
        type: PropType<(_resp: IServerSideHandler, _type: string | 'BEFORE SEND' | 'ERROR' | 'SUCCESS', _isLoadMore?: boolean) => void>;
    };
    onPopulateList: {
        required: false;
        type: PropType<(_term: string, _isLoadMore?: boolean) => void>;
    };
    optLabel: {
        required: true;
        type: (StringConstructor | FunctionConstructor)[];
    };
    optValue: {
        required: false;
        type: StringConstructor;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    search: {
        required: false;
        type: BooleanConstructor;
    };
    serverSide: {
        required: false;
        type: PropType<IServerSide>;
    };
    value: {
        required: false;
        type: PropType<number | String | Record<string, any> | number[] | Record<string, any>[] | String[] | null>;
    };
}>> & {
    onChange?: ((_selected: any) => any) | undefined;
    onInput?: ((_selected: any) => any) | undefined;
    onClose?: (() => any) | undefined;
    "onUpdate:modelValue"?: ((_selected: any) => any) | undefined;
    onOpen?: (() => any) | undefined;
}, {
    search: boolean;
    flat: boolean;
    required: boolean;
    disabled: boolean;
    isError: boolean;
    infinite: boolean;
    loadingText: string;
    multi: boolean;
    noResultText: string;
    readOnly: boolean;
    isLoading: boolean;
    allowClear: boolean;
    closeOnSelect: boolean;
}, {}>;
export default _default;
