import "./form-file-input.css";
import { defineComponent as I, resolveComponent as D, openBlock as a, createElementBlock as i, normalizeClass as q, withModifiers as s, createElementVNode as n, toDisplayString as d, createCommentVNode as o, mergeProps as b, createVNode as C, createSlots as T, withCtx as O, Fragment as g, renderList as $, createBlock as U, resolveDynamicComponent as M } from "vue";
import R from "../form-input/form-input.js";
import B from "../progress-bar/progress-bar.js";
import { r as L, x as N, d as P } from "../../icons-ba8254f6.js";
import { _ as z } from "../../_plugin-vue_export-helper-dad06003.js";
const j = I({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0,
    error: (e, t) => !0,
    input: (e) => !0,
    retry: (e) => !0,
    previewFile: (e) => !0
  },
  props: {
    allowClear: {
      required: !1,
      type: Boolean
    },
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    format: {
      required: !0,
      type: Object
    },
    helperText: {
      required: !1,
      type: String
    },
    isError: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    maxSize: {
      required: !1,
      type: Number
    },
    modelValue: {
      required: !1,
      type: Object
    },
    multi: {
      required: !1,
      type: Boolean
    },
    onDragText: {
      required: !1,
      type: String
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    uploadState: {
      required: !1,
      type: Object
    },
    value: {
      required: !1,
      type: Object
    },
    viewFile: {
      required: !1,
      type: Boolean
    }
  },
  name: "sb-form-file-input",
  components: {
    "sb-input": R,
    "sb-progress-bar": B
  },
  data() {
    return {
      icon: {
        onClick: null,
        onMouseLeave: null,
        onMouseOver: null,
        placement: "append"
      },
      iconSVG: null,
      localValue: this.modelValue || this.value || null,
      onDragOver: !1,
      onDragTimeout: null
    };
  },
  computed: {
    getFormatString() {
      return this.format.join(", ");
    },
    getIcon() {
      var e;
      if (this.localValue && this.localValue.length > 0) {
        if (((e = this.uploadState) == null ? void 0 : e.status) === "ERROR")
          return L();
        if (this.allowClear)
          return N();
      }
      return P();
    },
    getHumanFormats() {
      return this.format.map((e) => `*${e || ""}`).join(", ");
    },
    getOnDragText() {
      return this.onDragText ? this.onDragText : "Drag and drop your files here";
    },
    getProgressColor() {
      var e, t;
      if (((e = this.uploadState) == null ? void 0 : e.status) === "ERROR")
        return "danger";
      if (((t = this.uploadState) == null ? void 0 : t.status) === "SUCCESS")
        return "success";
    },
    isUploadVisible() {
      var e;
      return this.uploadState && ((e = this.uploadState) == null ? void 0 : e.status) !== "IDLE";
    }
  },
  methods: {
    doValidateFiles(e) {
      const t = e || this.localValue;
      if (this.isFormatValid(t)) {
        if (this.maxSize && !this.isSizeValid(t))
          return this.$emit("error", "INVALID SIZE"), !1;
      } else
        return this.$emit("error", "INVALID FORMAT", this.getHumanFormats), !1;
      return !0;
    },
    handleClear(e, t) {
      if (!this.readOnly && !this.disabled) {
        e.stopPropagation();
        const l = [...this.localValue];
        l.splice(t, 1), l.length < 1 && (this.$refs["input-file"].value = null), this.handleUpdateModelValue([...l]);
      }
    },
    handleClickIcon(e) {
      var t;
      e.stopPropagation(), !this.readOnly && !this.disabled && (this.allowClear && this.localValue && this.localValue.length > 0 ? ((t = this.uploadState) == null ? void 0 : t.status) === "ERROR" ? this.$emit("retry", this.localValue) : (this.$refs["input-file"].value = null, this.handleUpdateModelValue(null)) : this.handleOpenInput());
    },
    handleDragEnter() {
      this.onDragOver = !0, this.onDragTimeout && clearTimeout(this.onDragTimeout);
    },
    handleDragLeave() {
      this.onDragTimeout = setTimeout(() => {
        this.onDragOver = !1;
      }, 50);
    },
    handleDropFile(e) {
      var t;
      if (this.handleDragLeave(), (t = e.dataTransfer) != null && t.files) {
        const l = e.dataTransfer.files;
        if (this.doValidateFiles(l))
          return this.multi ? this.handleUpdateModelValue([
            ...this.localValue || [],
            ...l
          ]) : this.handleUpdateModelValue([...l]);
      }
    },
    handleOpenInput() {
      var e;
      !this.disabled && !this.readOnly && ((e = this.uploadState) == null ? void 0 : e.status) !== "UPLOADING" && this.$refs["input-file"].click();
    },
    handleSelectFile(e) {
      var t;
      if ((t = e.target) != null && t.value) {
        const l = e.target.files;
        if (this.doValidateFiles(l))
          return this.multi ? this.handleUpdateModelValue([
            ...this.localValue || [],
            ...l || []
          ]) : this.handleUpdateModelValue([...l]);
      }
      return this.handleUpdateModelValue(null);
    },
    handleUpdateModelValue(e) {
      this.localValue = [...e || []], this.$nextTick(() => {
        this.$emit("update:modelValue", this.localValue), this.$emit("change", this.localValue), this.$emit("input", this.localValue);
      });
    },
    handleView(e, t) {
      e.stopPropagation();
      const l = this.localValue[typeof t < "u" ? t : 0];
      this.$emit("previewFile", {
        file: l,
        type: l.type
      });
    },
    isFormatValid(e) {
      return [...e].every((p) => {
        const m = p.name.split(".").pop();
        return m ? this.format.indexOf(`.${m}`) > -1 : !0;
      });
    },
    isSizeValid(e) {
      return [...e].every((p) => this.maxSize ? +`${this.maxSize}000000` > p.size : !0);
    }
  },
  mounted() {
    this.icon.onClick = this.handleClickIcon, [
      "dragenter",
      "dragover",
      "dragleave",
      "drop"
    ].forEach((t) => {
      document.body.addEventListener(
        t,
        (l) => l.preventDefault()
      );
    });
  },
  unmounted() {
    [
      "dragenter",
      "dragover",
      "dragleave",
      "drop"
    ].forEach((t) => {
      document.body.removeEventListener(
        t,
        (l) => l.preventDefault()
      );
    });
  },
  watch: {
    localValue: {
      deep: !0,
      handler() {
        this.iconSVG = this.getIcon;
      },
      immediate: !0
    },
    modelValue: {
      deep: !0,
      handler(e) {
        e != null && e.length ? this.localValue = [...e] : this.localValue = null;
      }
    },
    uploadState: {
      deep: !0,
      handler(e) {
        e && ((e == null ? void 0 : e.status) === "ERROR" || (e == null ? void 0 : e.status) === "SUCCESS") && (this.iconSVG = this.getIcon);
      },
      immediate: !0
    },
    value: {
      deep: !0,
      handler(e) {
        e != null && e.length ? this.localValue = [...e] : this.localValue = null;
      }
    }
  }
});
const G = {
  key: 0,
  class: "drag-overlay"
}, A = { class: "text" }, H = {
  key: 1,
  class: "helper-text"
}, Z = { class: "input-group" }, J = ["accept"], K = {
  key: 1,
  class: "value-wrapper"
}, Q = ["onClick"], W = ["onClick"], X = ["onClick"], Y = {
  key: 0,
  class: "upload-progress-percentage"
};
function w(e, t, l, p, F, m) {
  var c, v, y, V, S;
  const k = D("sb-input"), E = D("sb-progress-bar");
  return a(), i("div", {
    class: q(["file-input-wrapper", {
      "on-drag": e.onDragOver,
      "upload-error": ((c = e.uploadState) == null ? void 0 : c.status) === "ERROR",
      uploaded: ((v = e.uploadState) == null ? void 0 : v.status) === "SUCCESS",
      uploading: e.isUploadVisible
    }]),
    onDragenter: t[4] || (t[4] = s((...r) => e.handleDragEnter && e.handleDragEnter(...r), ["prevent"])),
    onDragleave: t[5] || (t[5] = s((...r) => e.handleDragLeave && e.handleDragLeave(...r), ["prevent"])),
    onDragover: t[6] || (t[6] = s((...r) => e.handleDragEnter && e.handleDragEnter(...r), ["prevent"])),
    onDrop: t[7] || (t[7] = s((...r) => e.handleDropFile && e.handleDropFile(...r), ["prevent"])),
    onInput: () => !1,
    onBlur: () => !1
  }, [
    e.onDragOver ? (a(), i("div", G, [
      n("div", A, d(e.getOnDragText), 1)
    ])) : o("", !0),
    e.helperText ? (a(), i("label", H, d(e.helperText), 1)) : o("", !0),
    n("div", Z, [
      n("input", b({
        accept: e.getFormatString,
        ref: "input-file",
        type: "file"
      }, { multiple: e.multi }, {
        onChange: t[0] || (t[0] = (r) => e.handleSelectFile(r)),
        onInput: () => !1,
        onBlur: () => !1
      }), null, 16, J),
      C(k, b({
        class: { multi: e.multi },
        errorMessage: e.errorMessage,
        icon: e.icon,
        isError: e.isError,
        label: e.label
      }, {
        disabled: e.disabled,
        readOnly: e.readOnly,
        required: e.required,
        ...!e.readOnly && !e.disabled && {
          icon: e.icon
        }
      }, {
        modelValue: e.localValue,
        "onUpdate:modelValue": t[2] || (t[2] = (r) => e.localValue = r),
        onClick: t[3] || (t[3] = () => e.handleOpenInput()),
        onInput: () => !1,
        onBlur: () => !1
      }), T({
        "custom-input": O(() => {
          var r;
          return [
            e.localValue && e.localValue.length > 0 ? (a(), i(g, { key: 0 }, [
              e.multi ? o("", !0) : (a(), i("div", {
                key: 0,
                class: "value-wrapper",
                onClick: t[1] || (t[1] = (f) => e.viewFile && e.handleView(f))
              }, d((r = e.localValue[0]) == null ? void 0 : r.name), 1)),
              e.multi ? (a(), i("div", K, [
                (a(!0), i(g, null, $(e.localValue, (f, h) => (a(), i("div", {
                  class: "pill",
                  key: `pill-${h}`,
                  onClick: s(
                    (u) => !e.viewFile && e.handleClear(u, h),
                    ["stop"]
                  )
                }, [
                  n("div", {
                    class: "clear",
                    onClick: s(
                      (u) => e.handleClear(u, h),
                      ["stop"]
                    )
                  }, " x ", 8, W),
                  n("div", {
                    class: "content",
                    onClick: s(
                      (u) => e.handleView(u, h),
                      ["stop"]
                    )
                  }, [
                    n("span", null, d(f.name), 1)
                  ], 8, X)
                ], 8, Q))), 128))
              ])) : o("", !0)
            ], 64)) : o("", !0)
          ];
        }),
        _: 2
      }, [
        !e.readOnly && !e.disabled ? {
          name: "icon-slot",
          fn: O(() => [
            (a(), U(M(e.iconSVG)))
          ]),
          key: "0"
        } : void 0
      ]), 1040, ["class", "errorMessage", "icon", "isError", "label", "modelValue"]),
      e.isUploadVisible ? (a(), i(g, { key: 0 }, [
        ((y = e.uploadState) == null ? void 0 : y.status) === "UPLOADING" ? (a(), i("span", Y, d(((V = e.uploadState) == null ? void 0 : V.progress) || 0) + "% ", 1)) : o("", !0),
        C(E, {
          class: "upload-progress-bar",
          color: e.getProgressColor,
          height: 4,
          progress: ((S = e.uploadState) == null ? void 0 : S.progress) || 0
        }, null, 8, ["color", "progress"])
      ], 64)) : o("", !0)
    ])
  ], 34);
}
const re = /* @__PURE__ */ z(j, [["render", w]]);
export {
  re as default
};
