import "./form-input-number.css";
import { isRef as ve, ref as M, watch as V, onMounted as _e, onUnmounted as Ce, readonly as Ee, defineComponent as he, toRef as N, h as Fe, resolveComponent as Ae, openBlock as F, createElementBlock as A, mergeProps as ae, createElementVNode as y, normalizeClass as T, toDisplayString as Y, createCommentVNode as R, withModifiers as ye, renderSlot as Se, createVNode as Be, createBlock as ne, resolveDynamicComponent as ue, Fragment as re, createTextVNode as be } from "vue";
import { s as Ve, f as Ie } from "../../icons-ba8254f6.js";
import { _ as De } from "../../_plugin-vue_export-helper-dad06003.js";
function I(i) {
  return typeof i == "string" || i instanceof String;
}
function le(i) {
  var e;
  return typeof i == "object" && i != null && (i == null || (e = i.constructor) == null ? void 0 : e.name) === "Object";
}
function de(i, e) {
  return Array.isArray(e) ? de(i, (t, s) => e.includes(s)) : Object.entries(i).reduce((t, s) => {
    let [a, n] = s;
    return e(n, a) && (t[a] = n), t;
  }, {});
}
const h = {
  NONE: "NONE",
  LEFT: "LEFT",
  FORCE_LEFT: "FORCE_LEFT",
  RIGHT: "RIGHT",
  FORCE_RIGHT: "FORCE_RIGHT"
};
function xe(i) {
  switch (i) {
    case h.LEFT:
      return h.FORCE_LEFT;
    case h.RIGHT:
      return h.FORCE_RIGHT;
    default:
      return i;
  }
}
function Z(i) {
  return i.replace(/([.*+?^=!:${}()|[\]/\\])/g, "\\$1");
}
function P(i, e) {
  if (e === i)
    return !0;
  const t = Array.isArray(e), s = Array.isArray(i);
  let a;
  if (t && s) {
    if (e.length != i.length)
      return !1;
    for (a = 0; a < e.length; a++)
      if (!P(e[a], i[a]))
        return !1;
    return !0;
  }
  if (t != s)
    return !1;
  if (e && i && typeof e == "object" && typeof i == "object") {
    const n = e instanceof Date, u = i instanceof Date;
    if (n && u)
      return e.getTime() == i.getTime();
    if (n != u)
      return !1;
    const r = e instanceof RegExp, l = i instanceof RegExp;
    if (r && l)
      return e.toString() == i.toString();
    if (r != l)
      return !1;
    const o = Object.keys(e);
    for (a = 0; a < o.length; a++)
      if (!Object.prototype.hasOwnProperty.call(i, o[a]))
        return !1;
    for (a = 0; a < o.length; a++)
      if (!P(i[o[a]], e[o[a]]))
        return !1;
    return !0;
  } else if (e && i && typeof e == "function" && typeof i == "function")
    return e.toString() === i.toString();
  return !1;
}
class we {
  /** Current input value */
  /** Current cursor position */
  /** Old input value */
  /** Old selection */
  constructor(e) {
    for (Object.assign(this, e); this.value.slice(0, this.startChangePos) !== this.oldValue.slice(0, this.startChangePos); )
      --this.oldSelection.start;
    if (this.insertedCount)
      for (; this.value.slice(this.cursorPos) !== this.oldValue.slice(this.oldSelection.end); )
        this.value.length - this.cursorPos < this.oldValue.length - this.oldSelection.end ? ++this.oldSelection.end : ++this.cursorPos;
  }
  /** Start changing position */
  get startChangePos() {
    return Math.min(this.cursorPos, this.oldSelection.start);
  }
  /** Inserted symbols count */
  get insertedCount() {
    return this.cursorPos - this.startChangePos;
  }
  /** Inserted symbols */
  get inserted() {
    return this.value.substr(this.startChangePos, this.insertedCount);
  }
  /** Removed symbols count */
  get removedCount() {
    return Math.max(this.oldSelection.end - this.startChangePos || // for Delete
    this.oldValue.length - this.value.length, 0);
  }
  /** Removed symbols */
  get removed() {
    return this.oldValue.substr(this.startChangePos, this.removedCount);
  }
  /** Unchanged head symbols */
  get head() {
    return this.value.substring(0, this.startChangePos);
  }
  /** Unchanged tail symbols */
  get tail() {
    return this.value.substring(this.startChangePos + this.insertedCount);
  }
  /** Remove direction */
  get removeDirection() {
    return !this.removedCount || this.insertedCount ? h.NONE : (this.oldSelection.end === this.cursorPos || this.oldSelection.start === this.cursorPos) && // if not range removed (event with backspace)
    this.oldSelection.end === this.oldSelection.start ? h.RIGHT : h.LEFT;
  }
}
function p(i, e) {
  return new p.InputMask(i, e);
}
function pe(i) {
  if (i == null)
    throw new Error("mask property should be defined");
  return i instanceof RegExp ? p.MaskedRegExp : I(i) ? p.MaskedPattern : i === Date ? p.MaskedDate : i === Number ? p.MaskedNumber : Array.isArray(i) || i === Array ? p.MaskedDynamic : p.Masked && i.prototype instanceof p.Masked ? i : p.Masked && i instanceof p.Masked ? i.constructor : i instanceof Function ? p.MaskedFunction : (console.warn("Mask not found for mask", i), p.Masked);
}
function O(i) {
  if (!i)
    throw new Error("Options in not defined");
  if (p.Masked) {
    if (i.prototype instanceof p.Masked)
      return {
        mask: i
      };
    const {
      mask: e = void 0,
      ...t
    } = i instanceof p.Masked ? {
      mask: i
    } : le(i) && i.mask instanceof p.Masked ? i : {};
    if (e) {
      const s = e.mask;
      return {
        ...de(e, (a, n) => !n.startsWith("_")),
        mask: e.constructor,
        _mask: s,
        ...t
      };
    }
  }
  return le(i) ? {
    ...i
  } : {
    mask: i
  };
}
function b(i) {
  if (p.Masked && i instanceof p.Masked)
    return i;
  const e = O(i), t = pe(e.mask);
  if (!t)
    throw new Error("Masked class is not found for provided mask " + e.mask + ", appropriate module needs to be imported manually before creating mask.");
  return e.mask === t && delete e.mask, e._mask && (e.mask = e._mask, delete e._mask), new t(e);
}
p.createMask = b;
class W {
  /** */
  /** */
  /** */
  /** Safely returns selection start */
  get selectionStart() {
    let e;
    try {
      e = this._unsafeSelectionStart;
    } catch {
    }
    return e ?? this.value.length;
  }
  /** Safely returns selection end */
  get selectionEnd() {
    let e;
    try {
      e = this._unsafeSelectionEnd;
    } catch {
    }
    return e ?? this.value.length;
  }
  /** Safely sets element selection */
  select(e, t) {
    if (!(e == null || t == null || e === this.selectionStart && t === this.selectionEnd))
      try {
        this._unsafeSelect(e, t);
      } catch {
      }
  }
  /** */
  get isActive() {
    return !1;
  }
  /** */
  /** */
  /** */
}
p.MaskElement = W;
const oe = 90, Me = 89;
class $ extends W {
  /** HTMLElement to use mask on */
  constructor(e) {
    super(), this.input = e, this._onKeydown = this._onKeydown.bind(this), this._onInput = this._onInput.bind(this), this._onBeforeinput = this._onBeforeinput.bind(this), this._onCompositionEnd = this._onCompositionEnd.bind(this);
  }
  get rootElement() {
    var e, t, s;
    return (e = (t = (s = this.input).getRootNode) == null ? void 0 : t.call(s)) != null ? e : document;
  }
  /** Is element in focus */
  get isActive() {
    return this.input === this.rootElement.activeElement;
  }
  /** Binds HTMLElement events to mask internal events */
  bindEvents(e) {
    this.input.addEventListener("keydown", this._onKeydown), this.input.addEventListener("input", this._onInput), this.input.addEventListener("beforeinput", this._onBeforeinput), this.input.addEventListener("compositionend", this._onCompositionEnd), this.input.addEventListener("drop", e.drop), this.input.addEventListener("click", e.click), this.input.addEventListener("focus", e.focus), this.input.addEventListener("blur", e.commit), this._handlers = e;
  }
  _onKeydown(e) {
    if (this._handlers.redo && (e.keyCode === oe && e.shiftKey && (e.metaKey || e.ctrlKey) || e.keyCode === Me && e.ctrlKey))
      return e.preventDefault(), this._handlers.redo(e);
    if (this._handlers.undo && e.keyCode === oe && (e.metaKey || e.ctrlKey))
      return e.preventDefault(), this._handlers.undo(e);
    e.isComposing || this._handlers.selectionChange(e);
  }
  _onBeforeinput(e) {
    if (e.inputType === "historyUndo" && this._handlers.undo)
      return e.preventDefault(), this._handlers.undo(e);
    if (e.inputType === "historyRedo" && this._handlers.redo)
      return e.preventDefault(), this._handlers.redo(e);
  }
  _onCompositionEnd(e) {
    this._handlers.input(e);
  }
  _onInput(e) {
    e.isComposing || this._handlers.input(e);
  }
  /** Unbinds HTMLElement events to mask internal events */
  unbindEvents() {
    this.input.removeEventListener("keydown", this._onKeydown), this.input.removeEventListener("input", this._onInput), this.input.removeEventListener("beforeinput", this._onBeforeinput), this.input.removeEventListener("compositionend", this._onCompositionEnd), this.input.removeEventListener("drop", this._handlers.drop), this.input.removeEventListener("click", this._handlers.click), this.input.removeEventListener("focus", this._handlers.focus), this.input.removeEventListener("blur", this._handlers.commit), this._handlers = {};
  }
}
p.HTMLMaskElement = $;
class Te extends $ {
  /** InputElement to use mask on */
  constructor(e) {
    super(e), this.input = e;
  }
  /** Returns InputElement selection start */
  get _unsafeSelectionStart() {
    return this.input.selectionStart != null ? this.input.selectionStart : this.value.length;
  }
  /** Returns InputElement selection end */
  get _unsafeSelectionEnd() {
    return this.input.selectionEnd;
  }
  /** Sets InputElement selection */
  _unsafeSelect(e, t) {
    this.input.setSelectionRange(e, t);
  }
  get value() {
    return this.input.value;
  }
  set value(e) {
    this.input.value = e;
  }
}
p.HTMLMaskElement = $;
class ce extends $ {
  /** Returns HTMLElement selection start */
  get _unsafeSelectionStart() {
    const e = this.rootElement, t = e.getSelection && e.getSelection(), s = t && t.anchorOffset, a = t && t.focusOffset;
    return a == null || s == null || s < a ? s : a;
  }
  /** Returns HTMLElement selection end */
  get _unsafeSelectionEnd() {
    const e = this.rootElement, t = e.getSelection && e.getSelection(), s = t && t.anchorOffset, a = t && t.focusOffset;
    return a == null || s == null || s > a ? s : a;
  }
  /** Sets HTMLElement selection */
  _unsafeSelect(e, t) {
    if (!this.rootElement.createRange)
      return;
    const s = this.rootElement.createRange();
    s.setStart(this.input.firstChild || this.input, e), s.setEnd(this.input.lastChild || this.input, t);
    const a = this.rootElement, n = a.getSelection && a.getSelection();
    n && (n.removeAllRanges(), n.addRange(s));
  }
  /** HTMLElement value */
  get value() {
    return this.input.textContent || "";
  }
  set value(e) {
    this.input.textContent = e;
  }
}
p.HTMLContenteditableMaskElement = ce;
class H {
  constructor() {
    this.states = [], this.currentIndex = 0;
  }
  get currentState() {
    return this.states[this.currentIndex];
  }
  get isEmpty() {
    return this.states.length === 0;
  }
  push(e) {
    this.currentIndex < this.states.length - 1 && (this.states.length = this.currentIndex + 1), this.states.push(e), this.states.length > H.MAX_LENGTH && this.states.shift(), this.currentIndex = this.states.length - 1;
  }
  go(e) {
    return this.currentIndex = Math.min(Math.max(this.currentIndex + e, 0), this.states.length - 1), this.currentState;
  }
  undo() {
    return this.go(-1);
  }
  redo() {
    return this.go(1);
  }
  clear() {
    this.states.length = 0, this.currentIndex = 0;
  }
}
H.MAX_LENGTH = 100;
class Re {
  /**
    View element
  */
  /** Internal {@link Masked} model */
  constructor(e, t) {
    this.el = e instanceof W ? e : e.isContentEditable && e.tagName !== "INPUT" && e.tagName !== "TEXTAREA" ? new ce(e) : new Te(e), this.masked = b(t), this._listeners = {}, this._value = "", this._unmaskedValue = "", this._rawInputValue = "", this.history = new H(), this._saveSelection = this._saveSelection.bind(this), this._onInput = this._onInput.bind(this), this._onChange = this._onChange.bind(this), this._onDrop = this._onDrop.bind(this), this._onFocus = this._onFocus.bind(this), this._onClick = this._onClick.bind(this), this._onUndo = this._onUndo.bind(this), this._onRedo = this._onRedo.bind(this), this.alignCursor = this.alignCursor.bind(this), this.alignCursorFriendly = this.alignCursorFriendly.bind(this), this._bindEvents(), this.updateValue(), this._onChange();
  }
  maskEquals(e) {
    var t;
    return e == null || ((t = this.masked) == null ? void 0 : t.maskEquals(e));
  }
  /** Masked */
  get mask() {
    return this.masked.mask;
  }
  set mask(e) {
    if (this.maskEquals(e))
      return;
    if (!(e instanceof p.Masked) && this.masked.constructor === pe(e)) {
      this.masked.updateOptions({
        mask: e
      });
      return;
    }
    const t = e instanceof p.Masked ? e : b({
      mask: e
    });
    t.unmaskedValue = this.masked.unmaskedValue, this.masked = t;
  }
  /** Raw value */
  get value() {
    return this._value;
  }
  set value(e) {
    this.value !== e && (this.masked.value = e, this.updateControl("auto"));
  }
  /** Unmasked value */
  get unmaskedValue() {
    return this._unmaskedValue;
  }
  set unmaskedValue(e) {
    this.unmaskedValue !== e && (this.masked.unmaskedValue = e, this.updateControl("auto"));
  }
  /** Raw input value */
  get rawInputValue() {
    return this._rawInputValue;
  }
  set rawInputValue(e) {
    this.rawInputValue !== e && (this.masked.rawInputValue = e, this.updateControl(), this.alignCursor());
  }
  /** Typed unmasked value */
  get typedValue() {
    return this.masked.typedValue;
  }
  set typedValue(e) {
    this.masked.typedValueEquals(e) || (this.masked.typedValue = e, this.updateControl("auto"));
  }
  /** Display value */
  get displayValue() {
    return this.masked.displayValue;
  }
  /** Starts listening to element events */
  _bindEvents() {
    this.el.bindEvents({
      selectionChange: this._saveSelection,
      input: this._onInput,
      drop: this._onDrop,
      click: this._onClick,
      focus: this._onFocus,
      commit: this._onChange,
      undo: this._onUndo,
      redo: this._onRedo
    });
  }
  /** Stops listening to element events */
  _unbindEvents() {
    this.el && this.el.unbindEvents();
  }
  /** Fires custom event */
  _fireEvent(e, t) {
    const s = this._listeners[e];
    s && s.forEach((a) => a(t));
  }
  /** Current selection start */
  get selectionStart() {
    return this._cursorChanging ? this._changingCursorPos : this.el.selectionStart;
  }
  /** Current cursor position */
  get cursorPos() {
    return this._cursorChanging ? this._changingCursorPos : this.el.selectionEnd;
  }
  set cursorPos(e) {
    !this.el || !this.el.isActive || (this.el.select(e, e), this._saveSelection());
  }
  /** Stores current selection */
  _saveSelection() {
    this.displayValue !== this.el.value && console.warn("Element value was changed outside of mask. Syncronize mask using `mask.updateValue()` to work properly."), this._selection = {
      start: this.selectionStart,
      end: this.cursorPos
    };
  }
  /** Syncronizes model value from view */
  updateValue() {
    this.masked.value = this.el.value, this._value = this.masked.value, this._unmaskedValue = this.masked.unmaskedValue, this._rawInputValue = this.masked.rawInputValue;
  }
  /** Syncronizes view from model value, fires change events */
  updateControl(e) {
    const t = this.masked.unmaskedValue, s = this.masked.value, a = this.masked.rawInputValue, n = this.displayValue, u = this.unmaskedValue !== t || this.value !== s || this._rawInputValue !== a;
    this._unmaskedValue = t, this._value = s, this._rawInputValue = a, this.el.value !== n && (this.el.value = n), e === "auto" ? this.alignCursor() : e != null && (this.cursorPos = e), u && this._fireChangeEvents(), !this._historyChanging && (u || this.history.isEmpty) && this.history.push({
      unmaskedValue: t,
      selection: {
        start: this.selectionStart,
        end: this.cursorPos
      }
    });
  }
  /** Updates options with deep equal check, recreates {@link Masked} model if mask type changes */
  updateOptions(e) {
    const {
      mask: t,
      ...s
    } = e, a = !this.maskEquals(t), n = this.masked.optionsIsChanged(s);
    a && (this.mask = t), n && this.masked.updateOptions(s), (a || n) && this.updateControl();
  }
  /** Updates cursor */
  updateCursor(e) {
    e != null && (this.cursorPos = e, this._delayUpdateCursor(e));
  }
  /** Delays cursor update to support mobile browsers */
  _delayUpdateCursor(e) {
    this._abortUpdateCursor(), this._changingCursorPos = e, this._cursorChanging = setTimeout(() => {
      this.el && (this.cursorPos = this._changingCursorPos, this._abortUpdateCursor());
    }, 10);
  }
  /** Fires custom events */
  _fireChangeEvents() {
    this._fireEvent("accept", this._inputEvent), this.masked.isComplete && this._fireEvent("complete", this._inputEvent);
  }
  /** Aborts delayed cursor update */
  _abortUpdateCursor() {
    this._cursorChanging && (clearTimeout(this._cursorChanging), delete this._cursorChanging);
  }
  /** Aligns cursor to nearest available position */
  alignCursor() {
    this.cursorPos = this.masked.nearestInputPos(this.masked.nearestInputPos(this.cursorPos, h.LEFT));
  }
  /** Aligns cursor only if selection is empty */
  alignCursorFriendly() {
    this.selectionStart === this.cursorPos && this.alignCursor();
  }
  /** Adds listener on custom event */
  on(e, t) {
    return this._listeners[e] || (this._listeners[e] = []), this._listeners[e].push(t), this;
  }
  /** Removes custom event listener */
  off(e, t) {
    if (!this._listeners[e])
      return this;
    if (!t)
      return delete this._listeners[e], this;
    const s = this._listeners[e].indexOf(t);
    return s >= 0 && this._listeners[e].splice(s, 1), this;
  }
  /** Handles view input event */
  _onInput(e) {
    this._inputEvent = e, this._abortUpdateCursor();
    const t = new we({
      // new state
      value: this.el.value,
      cursorPos: this.cursorPos,
      // old state
      oldValue: this.displayValue,
      oldSelection: this._selection
    }), s = this.masked.rawInputValue, a = this.masked.splice(t.startChangePos, t.removed.length, t.inserted, t.removeDirection, {
      input: !0,
      raw: !0
    }).offset, n = s === this.masked.rawInputValue ? t.removeDirection : h.NONE;
    let u = this.masked.nearestInputPos(t.startChangePos + a, n);
    n !== h.NONE && (u = this.masked.nearestInputPos(u, h.NONE)), this.updateControl(u), delete this._inputEvent;
  }
  /** Handles view change event and commits model value */
  _onChange() {
    this.displayValue !== this.el.value && this.updateValue(), this.masked.doCommit(), this.updateControl(), this._saveSelection();
  }
  /** Handles view drop event, prevents by default */
  _onDrop(e) {
    e.preventDefault(), e.stopPropagation();
  }
  /** Restore last selection on focus */
  _onFocus(e) {
    this.alignCursorFriendly();
  }
  /** Restore last selection on focus */
  _onClick(e) {
    this.alignCursorFriendly();
  }
  _onUndo() {
    this._applyHistoryState(this.history.undo());
  }
  _onRedo() {
    this._applyHistoryState(this.history.redo());
  }
  _applyHistoryState(e) {
    e && (this._historyChanging = !0, this.unmaskedValue = e.unmaskedValue, this.el.select(e.selection.start, e.selection.end), this._saveSelection(), this._historyChanging = !1);
  }
  /** Unbind view events and removes element reference */
  destroy() {
    this._unbindEvents(), this._listeners.length = 0, delete this.el;
  }
}
p.InputMask = Re;
class c {
  /** Inserted symbols */
  /** Additional offset if any changes occurred before tail */
  /** Raw inserted is used by dynamic mask */
  /** Can skip chars */
  static normalize(e) {
    return Array.isArray(e) ? e : [e, new c()];
  }
  constructor(e) {
    Object.assign(this, {
      inserted: "",
      rawInserted: "",
      tailShift: 0,
      skip: !1
    }, e);
  }
  /** Aggregate changes */
  aggregate(e) {
    return this.inserted += e.inserted, this.rawInserted += e.rawInserted, this.tailShift += e.tailShift, this.skip = this.skip || e.skip, this;
  }
  /** Total offset considering all changes */
  get offset() {
    return this.tailShift + this.inserted.length;
  }
  get consumed() {
    return !!this.rawInserted || this.skip;
  }
  equals(e) {
    return this.inserted === e.inserted && this.tailShift === e.tailShift && this.rawInserted === e.rawInserted && this.skip === e.skip;
  }
}
p.ChangeDetails = c;
class S {
  /** Tail value as string */
  /** Tail start position */
  /** Start position */
  constructor(e, t, s) {
    e === void 0 && (e = ""), t === void 0 && (t = 0), this.value = e, this.from = t, this.stop = s;
  }
  toString() {
    return this.value;
  }
  extend(e) {
    this.value += String(e);
  }
  appendTo(e) {
    return e.append(this.toString(), {
      tail: !0
    }).aggregate(e._appendPlaceholder());
  }
  get state() {
    return {
      value: this.value,
      from: this.from,
      stop: this.stop
    };
  }
  set state(e) {
    Object.assign(this, e);
  }
  unshift(e) {
    if (!this.value.length || e != null && this.from >= e)
      return "";
    const t = this.value[0];
    return this.value = this.value.slice(1), t;
  }
  shift() {
    if (!this.value.length)
      return "";
    const e = this.value[this.value.length - 1];
    return this.value = this.value.slice(0, -1), e;
  }
}
class v {
  /** */
  /** */
  /** Transforms value before mask processing */
  /** Transforms each char before mask processing */
  /** Validates if value is acceptable */
  /** Does additional processing at the end of editing */
  /** Format typed value to string */
  /** Parse string to get typed value */
  /** Enable characters overwriting */
  /** */
  /** */
  /** */
  /** */
  constructor(e) {
    this._value = "", this._update({
      ...v.DEFAULTS,
      ...e
    }), this._initialized = !0;
  }
  /** Sets and applies new options */
  updateOptions(e) {
    this.optionsIsChanged(e) && this.withValueRefresh(this._update.bind(this, e));
  }
  /** Sets new options */
  _update(e) {
    Object.assign(this, e);
  }
  /** Mask state */
  get state() {
    return {
      _value: this.value,
      _rawInputValue: this.rawInputValue
    };
  }
  set state(e) {
    this._value = e._value;
  }
  /** Resets value */
  reset() {
    this._value = "";
  }
  get value() {
    return this._value;
  }
  set value(e) {
    this.resolve(e, {
      input: !0
    });
  }
  /** Resolve new value */
  resolve(e, t) {
    t === void 0 && (t = {
      input: !0
    }), this.reset(), this.append(e, t, ""), this.doCommit();
  }
  get unmaskedValue() {
    return this.value;
  }
  set unmaskedValue(e) {
    this.resolve(e, {});
  }
  get typedValue() {
    return this.parse ? this.parse(this.value, this) : this.unmaskedValue;
  }
  set typedValue(e) {
    this.format ? this.value = this.format(e, this) : this.unmaskedValue = String(e);
  }
  /** Value that includes raw user input */
  get rawInputValue() {
    return this.extractInput(0, this.displayValue.length, {
      raw: !0
    });
  }
  set rawInputValue(e) {
    this.resolve(e, {
      raw: !0
    });
  }
  get displayValue() {
    return this.value;
  }
  get isComplete() {
    return !0;
  }
  get isFilled() {
    return this.isComplete;
  }
  /** Finds nearest input position in direction */
  nearestInputPos(e, t) {
    return e;
  }
  totalInputPositions(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), Math.min(this.displayValue.length, t - e);
  }
  /** Extracts value in range considering flags */
  extractInput(e, t, s) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), this.displayValue.slice(e, t);
  }
  /** Extracts tail in range */
  extractTail(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), new S(this.extractInput(e, t), e);
  }
  /** Appends tail */
  appendTail(e) {
    return I(e) && (e = new S(String(e))), e.appendTo(this);
  }
  /** Appends char */
  _appendCharRaw(e, t) {
    return e ? (this._value += e, new c({
      inserted: e,
      rawInserted: e
    })) : new c();
  }
  /** Appends char */
  _appendChar(e, t, s) {
    t === void 0 && (t = {});
    const a = this.state;
    let n;
    if ([e, n] = this.doPrepareChar(e, t), e && (n = n.aggregate(this._appendCharRaw(e, t)), !n.rawInserted && this.autofix === "pad")) {
      const u = this.state;
      this.state = a;
      let r = this.pad(t);
      const l = this._appendCharRaw(e, t);
      r = r.aggregate(l), l.rawInserted || r.equals(n) ? n = r : this.state = u;
    }
    if (n.inserted) {
      let u, r = this.doValidate(t) !== !1;
      if (r && s != null) {
        const l = this.state;
        if (this.overwrite === !0) {
          u = s.state;
          for (let d = 0; d < n.rawInserted.length; ++d)
            s.unshift(this.displayValue.length - n.tailShift);
        }
        let o = this.appendTail(s);
        if (r = o.rawInserted.length === s.toString().length, !(r && o.inserted) && this.overwrite === "shift") {
          this.state = l, u = s.state;
          for (let d = 0; d < n.rawInserted.length; ++d)
            s.shift();
          o = this.appendTail(s), r = o.rawInserted.length === s.toString().length;
        }
        r && o.inserted && (this.state = l);
      }
      r || (n = new c(), this.state = a, s && u && (s.state = u));
    }
    return n;
  }
  /** Appends optional placeholder at the end */
  _appendPlaceholder() {
    return new c();
  }
  /** Appends optional eager placeholder at the end */
  _appendEager() {
    return new c();
  }
  /** Appends symbols considering flags */
  append(e, t, s) {
    if (!I(e))
      throw new Error("value should be string");
    const a = I(s) ? new S(String(s)) : s;
    t != null && t.tail && (t._beforeTailState = this.state);
    let n;
    [e, n] = this.doPrepare(e, t);
    for (let u = 0; u < e.length; ++u) {
      const r = this._appendChar(e[u], t, a);
      if (!r.rawInserted && !this.doSkipInvalid(e[u], t, a))
        break;
      n.aggregate(r);
    }
    return (this.eager === !0 || this.eager === "append") && t != null && t.input && e && n.aggregate(this._appendEager()), a != null && (n.tailShift += this.appendTail(a).tailShift), n;
  }
  remove(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), this._value = this.displayValue.slice(0, e) + this.displayValue.slice(t), new c();
  }
  /** Calls function and reapplies current value */
  withValueRefresh(e) {
    if (this._refreshing || !this._initialized)
      return e();
    this._refreshing = !0;
    const t = this.rawInputValue, s = this.value, a = e();
    return this.rawInputValue = t, this.value && this.value !== s && s.indexOf(this.value) === 0 && (this.append(s.slice(this.displayValue.length), {}, ""), this.doCommit()), delete this._refreshing, a;
  }
  runIsolated(e) {
    if (this._isolated || !this._initialized)
      return e(this);
    this._isolated = !0;
    const t = this.state, s = e(this);
    return this.state = t, delete this._isolated, s;
  }
  doSkipInvalid(e, t, s) {
    return !!this.skipInvalid;
  }
  /** Prepares string before mask processing */
  doPrepare(e, t) {
    return t === void 0 && (t = {}), c.normalize(this.prepare ? this.prepare(e, this, t) : e);
  }
  /** Prepares each char before mask processing */
  doPrepareChar(e, t) {
    return t === void 0 && (t = {}), c.normalize(this.prepareChar ? this.prepareChar(e, this, t) : e);
  }
  /** Validates if value is acceptable */
  doValidate(e) {
    return (!this.validate || this.validate(this.value, this, e)) && (!this.parent || this.parent.doValidate(e));
  }
  /** Does additional processing at the end of editing */
  doCommit() {
    this.commit && this.commit(this.value, this);
  }
  splice(e, t, s, a, n) {
    s === void 0 && (s = ""), a === void 0 && (a = h.NONE), n === void 0 && (n = {
      input: !0
    });
    const u = e + t, r = this.extractTail(u), l = this.eager === !0 || this.eager === "remove";
    let o;
    l && (a = xe(a), o = this.extractInput(0, u, {
      raw: !0
    }));
    let d = e;
    const m = new c();
    if (a !== h.NONE && (d = this.nearestInputPos(e, t > 1 && e !== 0 && !l ? h.NONE : a), m.tailShift = d - e), m.aggregate(this.remove(d)), l && a !== h.NONE && o === this.rawInputValue)
      if (a === h.FORCE_LEFT) {
        let k;
        for (; o === this.rawInputValue && (k = this.displayValue.length); )
          m.aggregate(new c({
            tailShift: -1
          })).aggregate(this.remove(k - 1));
      } else
        a === h.FORCE_RIGHT && r.unshift();
    return m.aggregate(this.append(s, n, r));
  }
  maskEquals(e) {
    return this.mask === e;
  }
  optionsIsChanged(e) {
    return !P(this, e);
  }
  typedValueEquals(e) {
    const t = this.typedValue;
    return e === t || v.EMPTY_VALUES.includes(e) && v.EMPTY_VALUES.includes(t) || (this.format ? this.format(e, this) === this.format(this.typedValue, this) : !1);
  }
  pad(e) {
    return new c();
  }
}
v.DEFAULTS = {
  skipInvalid: !0
};
v.EMPTY_VALUES = [void 0, null, ""];
p.Masked = v;
class x {
  /** */
  constructor(e, t) {
    e === void 0 && (e = []), t === void 0 && (t = 0), this.chunks = e, this.from = t;
  }
  toString() {
    return this.chunks.map(String).join("");
  }
  extend(e) {
    if (!String(e))
      return;
    e = I(e) ? new S(String(e)) : e;
    const t = this.chunks[this.chunks.length - 1], s = t && // if stops are same or tail has no stop
    (t.stop === e.stop || e.stop == null) && // if tail chunk goes just after last chunk
    e.from === t.from + t.toString().length;
    if (e instanceof S)
      s ? t.extend(e.toString()) : this.chunks.push(e);
    else if (e instanceof x) {
      if (e.stop == null) {
        let a;
        for (; e.chunks.length && e.chunks[0].stop == null; )
          a = e.chunks.shift(), a.from += e.from, this.extend(a);
      }
      e.toString() && (e.stop = e.blockIndex, this.chunks.push(e));
    }
  }
  appendTo(e) {
    if (!(e instanceof p.MaskedPattern))
      return new S(this.toString()).appendTo(e);
    const t = new c();
    for (let s = 0; s < this.chunks.length; ++s) {
      const a = this.chunks[s], n = e._mapPosToBlock(e.displayValue.length), u = a.stop;
      let r;
      if (u != null && // if block not found or stop is behind lastBlock
      (!n || n.index <= u) && ((a instanceof x || // for continuous block also check if stop is exist
      e._stops.indexOf(u) >= 0) && t.aggregate(e._appendPlaceholder(u)), r = a instanceof x && e._blocks[u]), r) {
        const l = r.appendTail(a);
        t.aggregate(l);
        const o = a.toString().slice(l.rawInserted.length);
        o && t.aggregate(e.append(o, {
          tail: !0
        }));
      } else
        t.aggregate(e.append(a.toString(), {
          tail: !0
        }));
    }
    return t;
  }
  get state() {
    return {
      chunks: this.chunks.map((e) => e.state),
      from: this.from,
      stop: this.stop,
      blockIndex: this.blockIndex
    };
  }
  set state(e) {
    const {
      chunks: t,
      ...s
    } = e;
    Object.assign(this, s), this.chunks = t.map((a) => {
      const n = "chunks" in a ? new x() : new S();
      return n.state = a, n;
    });
  }
  unshift(e) {
    if (!this.chunks.length || e != null && this.from >= e)
      return "";
    const t = e != null ? e - this.from : e;
    let s = 0;
    for (; s < this.chunks.length; ) {
      const a = this.chunks[s], n = a.unshift(t);
      if (a.toString()) {
        if (!n)
          break;
        ++s;
      } else
        this.chunks.splice(s, 1);
      if (n)
        return n;
    }
    return "";
  }
  shift() {
    if (!this.chunks.length)
      return "";
    let e = this.chunks.length - 1;
    for (; 0 <= e; ) {
      const t = this.chunks[e], s = t.shift();
      if (t.toString()) {
        if (!s)
          break;
        --e;
      } else
        this.chunks.splice(e, 1);
      if (s)
        return s;
    }
    return "";
  }
}
class Oe {
  constructor(e, t) {
    this.masked = e, this._log = [];
    const {
      offset: s,
      index: a
    } = e._mapPosToBlock(t) || (t < 0 ? (
      // first
      {
        index: 0,
        offset: 0
      }
    ) : (
      // last
      {
        index: this.masked._blocks.length,
        offset: 0
      }
    ));
    this.offset = s, this.index = a, this.ok = !1;
  }
  get block() {
    return this.masked._blocks[this.index];
  }
  get pos() {
    return this.masked._blockStartPos(this.index) + this.offset;
  }
  get state() {
    return {
      index: this.index,
      offset: this.offset,
      ok: this.ok
    };
  }
  set state(e) {
    Object.assign(this, e);
  }
  pushState() {
    this._log.push(this.state);
  }
  popState() {
    const e = this._log.pop();
    return e && (this.state = e), e;
  }
  bindBlock() {
    this.block || (this.index < 0 && (this.index = 0, this.offset = 0), this.index >= this.masked._blocks.length && (this.index = this.masked._blocks.length - 1, this.offset = this.block.displayValue.length));
  }
  _pushLeft(e) {
    for (this.pushState(), this.bindBlock(); 0 <= this.index; --this.index, this.offset = ((t = this.block) == null ? void 0 : t.displayValue.length) || 0) {
      var t;
      if (e())
        return this.ok = !0;
    }
    return this.ok = !1;
  }
  _pushRight(e) {
    for (this.pushState(), this.bindBlock(); this.index < this.masked._blocks.length; ++this.index, this.offset = 0)
      if (e())
        return this.ok = !0;
    return this.ok = !1;
  }
  pushLeftBeforeFilled() {
    return this._pushLeft(() => {
      if (!(this.block.isFixed || !this.block.value) && (this.offset = this.block.nearestInputPos(this.offset, h.FORCE_LEFT), this.offset !== 0))
        return !0;
    });
  }
  pushLeftBeforeInput() {
    return this._pushLeft(() => {
      if (!this.block.isFixed)
        return this.offset = this.block.nearestInputPos(this.offset, h.LEFT), !0;
    });
  }
  pushLeftBeforeRequired() {
    return this._pushLeft(() => {
      if (!(this.block.isFixed || this.block.isOptional && !this.block.value))
        return this.offset = this.block.nearestInputPos(this.offset, h.LEFT), !0;
    });
  }
  pushRightBeforeFilled() {
    return this._pushRight(() => {
      if (!(this.block.isFixed || !this.block.value) && (this.offset = this.block.nearestInputPos(this.offset, h.FORCE_RIGHT), this.offset !== this.block.value.length))
        return !0;
    });
  }
  pushRightBeforeInput() {
    return this._pushRight(() => {
      if (!this.block.isFixed)
        return this.offset = this.block.nearestInputPos(this.offset, h.NONE), !0;
    });
  }
  pushRightBeforeRequired() {
    return this._pushRight(() => {
      if (!(this.block.isFixed || this.block.isOptional && !this.block.value))
        return this.offset = this.block.nearestInputPos(this.offset, h.NONE), !0;
    });
  }
}
class fe {
  /** */
  /** */
  /** */
  /** */
  /** */
  /** */
  constructor(e) {
    Object.assign(this, e), this._value = "", this.isFixed = !0;
  }
  get value() {
    return this._value;
  }
  get unmaskedValue() {
    return this.isUnmasking ? this.value : "";
  }
  get rawInputValue() {
    return this._isRawInput ? this.value : "";
  }
  get displayValue() {
    return this.value;
  }
  reset() {
    this._isRawInput = !1, this._value = "";
  }
  remove(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this._value.length), this._value = this._value.slice(0, e) + this._value.slice(t), this._value || (this._isRawInput = !1), new c();
  }
  nearestInputPos(e, t) {
    t === void 0 && (t = h.NONE);
    const s = 0, a = this._value.length;
    switch (t) {
      case h.LEFT:
      case h.FORCE_LEFT:
        return s;
      case h.NONE:
      case h.RIGHT:
      case h.FORCE_RIGHT:
      default:
        return a;
    }
  }
  totalInputPositions(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this._value.length), this._isRawInput ? t - e : 0;
  }
  extractInput(e, t, s) {
    return e === void 0 && (e = 0), t === void 0 && (t = this._value.length), s === void 0 && (s = {}), s.raw && this._isRawInput && this._value.slice(e, t) || "";
  }
  get isComplete() {
    return !0;
  }
  get isFilled() {
    return !!this._value;
  }
  _appendChar(e, t) {
    if (t === void 0 && (t = {}), this.isFilled)
      return new c();
    const s = this.eager === !0 || this.eager === "append", n = this.char === e && (this.isUnmasking || t.input || t.raw) && (!t.raw || !s) && !t.tail, u = new c({
      inserted: this.char,
      rawInserted: n ? this.char : ""
    });
    return this._value = this.char, this._isRawInput = n && (t.raw || t.input), u;
  }
  _appendEager() {
    return this._appendChar(this.char, {
      tail: !0
    });
  }
  _appendPlaceholder() {
    const e = new c();
    return this.isFilled || (this._value = e.inserted = this.char), e;
  }
  extractTail() {
    return new S("");
  }
  appendTail(e) {
    return I(e) && (e = new S(String(e))), e.appendTo(this);
  }
  append(e, t, s) {
    const a = this._appendChar(e[0], t);
    return s != null && (a.tailShift += this.appendTail(s).tailShift), a;
  }
  doCommit() {
  }
  get state() {
    return {
      _value: this._value,
      _rawInputValue: this.rawInputValue
    };
  }
  set state(e) {
    this._value = e._value, this._isRawInput = !!e._rawInputValue;
  }
  pad(e) {
    return this._appendPlaceholder();
  }
}
class q {
  /** */
  /** */
  /** */
  /** */
  /** */
  /** */
  /** */
  /** */
  constructor(e) {
    const {
      parent: t,
      isOptional: s,
      placeholderChar: a,
      displayChar: n,
      lazy: u,
      eager: r,
      ...l
    } = e;
    this.masked = b(l), Object.assign(this, {
      parent: t,
      isOptional: s,
      placeholderChar: a,
      displayChar: n,
      lazy: u,
      eager: r
    });
  }
  reset() {
    this.isFilled = !1, this.masked.reset();
  }
  remove(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.value.length), e === 0 && t >= 1 ? (this.isFilled = !1, this.masked.remove(e, t)) : new c();
  }
  get value() {
    return this.masked.value || (this.isFilled && !this.isOptional ? this.placeholderChar : "");
  }
  get unmaskedValue() {
    return this.masked.unmaskedValue;
  }
  get rawInputValue() {
    return this.masked.rawInputValue;
  }
  get displayValue() {
    return this.masked.value && this.displayChar || this.value;
  }
  get isComplete() {
    return !!this.masked.value || this.isOptional;
  }
  _appendChar(e, t) {
    if (t === void 0 && (t = {}), this.isFilled)
      return new c();
    const s = this.masked.state;
    let a = this.masked._appendChar(e, this.currentMaskFlags(t));
    return a.inserted && this.doValidate(t) === !1 && (a = new c(), this.masked.state = s), !a.inserted && !this.isOptional && !this.lazy && !t.input && (a.inserted = this.placeholderChar), a.skip = !a.inserted && !this.isOptional, this.isFilled = !!a.inserted, a;
  }
  append(e, t, s) {
    return this.masked.append(e, this.currentMaskFlags(t), s);
  }
  _appendPlaceholder() {
    return this.isFilled || this.isOptional ? new c() : (this.isFilled = !0, new c({
      inserted: this.placeholderChar
    }));
  }
  _appendEager() {
    return new c();
  }
  extractTail(e, t) {
    return this.masked.extractTail(e, t);
  }
  appendTail(e) {
    return this.masked.appendTail(e);
  }
  extractInput(e, t, s) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.value.length), this.masked.extractInput(e, t, s);
  }
  nearestInputPos(e, t) {
    t === void 0 && (t = h.NONE);
    const s = 0, a = this.value.length, n = Math.min(Math.max(e, s), a);
    switch (t) {
      case h.LEFT:
      case h.FORCE_LEFT:
        return this.isComplete ? n : s;
      case h.RIGHT:
      case h.FORCE_RIGHT:
        return this.isComplete ? n : a;
      case h.NONE:
      default:
        return n;
    }
  }
  totalInputPositions(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.value.length), this.value.slice(e, t).length;
  }
  doValidate(e) {
    return this.masked.doValidate(this.currentMaskFlags(e)) && (!this.parent || this.parent.doValidate(this.currentMaskFlags(e)));
  }
  doCommit() {
    this.masked.doCommit();
  }
  get state() {
    return {
      _value: this.value,
      _rawInputValue: this.rawInputValue,
      masked: this.masked.state,
      isFilled: this.isFilled
    };
  }
  set state(e) {
    this.masked.state = e.masked, this.isFilled = e.isFilled;
  }
  currentMaskFlags(e) {
    var t;
    return {
      ...e,
      _beforeTailState: (e == null || (t = e._beforeTailState) == null ? void 0 : t.masked) || (e == null ? void 0 : e._beforeTailState)
    };
  }
  pad(e) {
    return new c();
  }
}
q.DEFAULT_DEFINITIONS = {
  0: /\d/,
  a: /[\u0041-\u005A\u0061-\u007A\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/,
  // http://stackoverflow.com/a/22075070
  "*": /./
};
class Le extends v {
  /** */
  /** Enable characters overwriting */
  /** */
  /** */
  /** */
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    const t = e.mask;
    t && (e.validate = (s) => s.search(t) >= 0), super._update(e);
  }
}
p.MaskedRegExp = Le;
class _ extends v {
  /** */
  /** */
  /** Single char for empty input */
  /** Single char for filled input */
  /** Show placeholder only when needed */
  /** Enable characters overwriting */
  /** */
  /** */
  /** */
  constructor(e) {
    super({
      ..._.DEFAULTS,
      ...e,
      definitions: Object.assign({}, q.DEFAULT_DEFINITIONS, e == null ? void 0 : e.definitions)
    });
  }
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    e.definitions = Object.assign({}, this.definitions, e.definitions), super._update(e), this._rebuildMask();
  }
  _rebuildMask() {
    const e = this.definitions;
    this._blocks = [], this.exposeBlock = void 0, this._stops = [], this._maskedBlocks = {};
    const t = this.mask;
    if (!t || !e)
      return;
    let s = !1, a = !1;
    for (let n = 0; n < t.length; ++n) {
      if (this.blocks) {
        const o = t.slice(n), d = Object.keys(this.blocks).filter((k) => o.indexOf(k) === 0);
        d.sort((k, f) => f.length - k.length);
        const m = d[0];
        if (m) {
          const {
            expose: k,
            repeat: f,
            ...C
          } = O(this.blocks[m]), w = {
            lazy: this.lazy,
            eager: this.eager,
            placeholderChar: this.placeholderChar,
            displayChar: this.displayChar,
            overwrite: this.overwrite,
            autofix: this.autofix,
            ...C,
            repeat: f,
            parent: this
          }, D = f != null ? new p.RepeatBlock(
            w
            /* TODO */
          ) : b(w);
          D && (this._blocks.push(D), k && (this.exposeBlock = D), this._maskedBlocks[m] || (this._maskedBlocks[m] = []), this._maskedBlocks[m].push(this._blocks.length - 1)), n += m.length - 1;
          continue;
        }
      }
      let u = t[n], r = u in e;
      if (u === _.STOP_CHAR) {
        this._stops.push(this._blocks.length);
        continue;
      }
      if (u === "{" || u === "}") {
        s = !s;
        continue;
      }
      if (u === "[" || u === "]") {
        a = !a;
        continue;
      }
      if (u === _.ESCAPE_CHAR) {
        if (++n, u = t[n], !u)
          break;
        r = !1;
      }
      const l = r ? new q({
        isOptional: a,
        lazy: this.lazy,
        eager: this.eager,
        placeholderChar: this.placeholderChar,
        displayChar: this.displayChar,
        ...O(e[u]),
        parent: this
      }) : new fe({
        char: u,
        eager: this.eager,
        isUnmasking: s
      });
      this._blocks.push(l);
    }
  }
  get state() {
    return {
      ...super.state,
      _blocks: this._blocks.map((e) => e.state)
    };
  }
  set state(e) {
    if (!e) {
      this.reset();
      return;
    }
    const {
      _blocks: t,
      ...s
    } = e;
    this._blocks.forEach((a, n) => a.state = t[n]), super.state = s;
  }
  reset() {
    super.reset(), this._blocks.forEach((e) => e.reset());
  }
  get isComplete() {
    return this.exposeBlock ? this.exposeBlock.isComplete : this._blocks.every((e) => e.isComplete);
  }
  get isFilled() {
    return this._blocks.every((e) => e.isFilled);
  }
  get isFixed() {
    return this._blocks.every((e) => e.isFixed);
  }
  get isOptional() {
    return this._blocks.every((e) => e.isOptional);
  }
  doCommit() {
    this._blocks.forEach((e) => e.doCommit()), super.doCommit();
  }
  get unmaskedValue() {
    return this.exposeBlock ? this.exposeBlock.unmaskedValue : this._blocks.reduce((e, t) => e += t.unmaskedValue, "");
  }
  set unmaskedValue(e) {
    if (this.exposeBlock) {
      const t = this.extractTail(this._blockStartPos(this._blocks.indexOf(this.exposeBlock)) + this.exposeBlock.displayValue.length);
      this.exposeBlock.unmaskedValue = e, this.appendTail(t), this.doCommit();
    } else
      super.unmaskedValue = e;
  }
  get value() {
    return this.exposeBlock ? this.exposeBlock.value : (
      // TODO return _value when not in change?
      this._blocks.reduce((e, t) => e += t.value, "")
    );
  }
  set value(e) {
    if (this.exposeBlock) {
      const t = this.extractTail(this._blockStartPos(this._blocks.indexOf(this.exposeBlock)) + this.exposeBlock.displayValue.length);
      this.exposeBlock.value = e, this.appendTail(t), this.doCommit();
    } else
      super.value = e;
  }
  get typedValue() {
    return this.exposeBlock ? this.exposeBlock.typedValue : super.typedValue;
  }
  set typedValue(e) {
    if (this.exposeBlock) {
      const t = this.extractTail(this._blockStartPos(this._blocks.indexOf(this.exposeBlock)) + this.exposeBlock.displayValue.length);
      this.exposeBlock.typedValue = e, this.appendTail(t), this.doCommit();
    } else
      super.typedValue = e;
  }
  get displayValue() {
    return this._blocks.reduce((e, t) => e += t.displayValue, "");
  }
  appendTail(e) {
    return super.appendTail(e).aggregate(this._appendPlaceholder());
  }
  _appendEager() {
    var e;
    const t = new c();
    let s = (e = this._mapPosToBlock(this.displayValue.length)) == null ? void 0 : e.index;
    if (s == null)
      return t;
    this._blocks[s].isFilled && ++s;
    for (let a = s; a < this._blocks.length; ++a) {
      const n = this._blocks[a]._appendEager();
      if (!n.inserted)
        break;
      t.aggregate(n);
    }
    return t;
  }
  _appendCharRaw(e, t) {
    t === void 0 && (t = {});
    const s = this._mapPosToBlock(this.displayValue.length), a = new c();
    if (!s)
      return a;
    for (let u = s.index, r; r = this._blocks[u]; ++u) {
      var n;
      const l = r._appendChar(e, {
        ...t,
        _beforeTailState: (n = t._beforeTailState) == null || (n = n._blocks) == null ? void 0 : n[u]
      });
      if (a.aggregate(l), l.consumed)
        break;
    }
    return a;
  }
  extractTail(e, t) {
    e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length);
    const s = new x();
    return e === t || this._forEachBlocksInRange(e, t, (a, n, u, r) => {
      const l = a.extractTail(u, r);
      l.stop = this._findStopBefore(n), l.from = this._blockStartPos(n), l instanceof x && (l.blockIndex = n), s.extend(l);
    }), s;
  }
  extractInput(e, t, s) {
    if (e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), s === void 0 && (s = {}), e === t)
      return "";
    let a = "";
    return this._forEachBlocksInRange(e, t, (n, u, r, l) => {
      a += n.extractInput(r, l, s);
    }), a;
  }
  _findStopBefore(e) {
    let t;
    for (let s = 0; s < this._stops.length; ++s) {
      const a = this._stops[s];
      if (a <= e)
        t = a;
      else
        break;
    }
    return t;
  }
  /** Appends placeholder depending on laziness */
  _appendPlaceholder(e) {
    const t = new c();
    if (this.lazy && e == null)
      return t;
    const s = this._mapPosToBlock(this.displayValue.length);
    if (!s)
      return t;
    const a = s.index, n = e ?? this._blocks.length;
    return this._blocks.slice(a, n).forEach((u) => {
      if (!u.lazy || e != null) {
        var r;
        t.aggregate(u._appendPlaceholder((r = u._blocks) == null ? void 0 : r.length));
      }
    }), t;
  }
  /** Finds block in pos */
  _mapPosToBlock(e) {
    let t = "";
    for (let s = 0; s < this._blocks.length; ++s) {
      const a = this._blocks[s], n = t.length;
      if (t += a.displayValue, e <= t.length)
        return {
          index: s,
          offset: e - n
        };
    }
  }
  _blockStartPos(e) {
    return this._blocks.slice(0, e).reduce((t, s) => t += s.displayValue.length, 0);
  }
  _forEachBlocksInRange(e, t, s) {
    t === void 0 && (t = this.displayValue.length);
    const a = this._mapPosToBlock(e);
    if (a) {
      const n = this._mapPosToBlock(t), u = n && a.index === n.index, r = a.offset, l = n && u ? n.offset : this._blocks[a.index].displayValue.length;
      if (s(this._blocks[a.index], a.index, r, l), n && !u) {
        for (let o = a.index + 1; o < n.index; ++o)
          s(this._blocks[o], o, 0, this._blocks[o].displayValue.length);
        s(this._blocks[n.index], n.index, 0, n.offset);
      }
    }
  }
  remove(e, t) {
    e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length);
    const s = super.remove(e, t);
    return this._forEachBlocksInRange(e, t, (a, n, u, r) => {
      s.aggregate(a.remove(u, r));
    }), s;
  }
  nearestInputPos(e, t) {
    if (t === void 0 && (t = h.NONE), !this._blocks.length)
      return 0;
    const s = new Oe(this, e);
    if (t === h.NONE)
      return s.pushRightBeforeInput() || (s.popState(), s.pushLeftBeforeInput()) ? s.pos : this.displayValue.length;
    if (t === h.LEFT || t === h.FORCE_LEFT) {
      if (t === h.LEFT) {
        if (s.pushRightBeforeFilled(), s.ok && s.pos === e)
          return e;
        s.popState();
      }
      if (s.pushLeftBeforeInput(), s.pushLeftBeforeRequired(), s.pushLeftBeforeFilled(), t === h.LEFT) {
        if (s.pushRightBeforeInput(), s.pushRightBeforeRequired(), s.ok && s.pos <= e || (s.popState(), s.ok && s.pos <= e))
          return s.pos;
        s.popState();
      }
      return s.ok ? s.pos : t === h.FORCE_LEFT ? 0 : (s.popState(), s.ok || (s.popState(), s.ok) ? s.pos : 0);
    }
    return t === h.RIGHT || t === h.FORCE_RIGHT ? (s.pushRightBeforeInput(), s.pushRightBeforeRequired(), s.pushRightBeforeFilled() ? s.pos : t === h.FORCE_RIGHT ? this.displayValue.length : (s.popState(), s.ok || (s.popState(), s.ok) ? s.pos : this.nearestInputPos(e, h.LEFT))) : e;
  }
  totalInputPositions(e, t) {
    e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length);
    let s = 0;
    return this._forEachBlocksInRange(e, t, (a, n, u, r) => {
      s += a.totalInputPositions(u, r);
    }), s;
  }
  /** Get block by name */
  maskedBlock(e) {
    return this.maskedBlocks(e)[0];
  }
  /** Get all blocks by name */
  maskedBlocks(e) {
    const t = this._maskedBlocks[e];
    return t ? t.map((s) => this._blocks[s]) : [];
  }
  pad(e) {
    const t = new c();
    return this._forEachBlocksInRange(0, this.displayValue.length, (s) => t.aggregate(s.pad(e))), t;
  }
}
_.DEFAULTS = {
  ...v.DEFAULTS,
  lazy: !0,
  placeholderChar: "_"
};
_.STOP_CHAR = "`";
_.ESCAPE_CHAR = "\\";
_.InputDefinition = q;
_.FixedDefinition = fe;
p.MaskedPattern = _;
class U extends _ {
  /**
    Optionally sets max length of pattern.
    Used when pattern length is longer then `to` param length. Pads zeros at start in this case.
  */
  /** Min bound */
  /** Max bound */
  get _matchFrom() {
    return this.maxLength - String(this.from).length;
  }
  constructor(e) {
    super(e);
  }
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    const {
      to: t = this.to || 0,
      from: s = this.from || 0,
      maxLength: a = this.maxLength || 0,
      autofix: n = this.autofix,
      ...u
    } = e;
    this.to = t, this.from = s, this.maxLength = Math.max(String(t).length, a), this.autofix = n;
    const r = String(this.from).padStart(this.maxLength, "0"), l = String(this.to).padStart(this.maxLength, "0");
    let o = 0;
    for (; o < l.length && l[o] === r[o]; )
      ++o;
    u.mask = l.slice(0, o).replace(/0/g, "\\0") + "0".repeat(this.maxLength - o), super._update(u);
  }
  get isComplete() {
    return super.isComplete && !!this.value;
  }
  boundaries(e) {
    let t = "", s = "";
    const [, a, n] = e.match(/^(\D*)(\d*)(\D*)/) || [];
    return n && (t = "0".repeat(a.length) + n, s = "9".repeat(a.length) + n), t = t.padEnd(this.maxLength, "0"), s = s.padEnd(this.maxLength, "9"), [t, s];
  }
  doPrepareChar(e, t) {
    t === void 0 && (t = {});
    let s;
    return [e, s] = super.doPrepareChar(e.replace(/\D/g, ""), t), e || (s.skip = !this.isComplete), [e, s];
  }
  _appendCharRaw(e, t) {
    if (t === void 0 && (t = {}), !this.autofix || this.value.length + 1 > this.maxLength)
      return super._appendCharRaw(e, t);
    const s = String(this.from).padStart(this.maxLength, "0"), a = String(this.to).padStart(this.maxLength, "0"), [n, u] = this.boundaries(this.value + e);
    return Number(u) < this.from ? super._appendCharRaw(s[this.value.length], t) : Number(n) > this.to ? !t.tail && this.autofix === "pad" && this.value.length + 1 < this.maxLength ? super._appendCharRaw(s[this.value.length], t).aggregate(this._appendCharRaw(e, t)) : super._appendCharRaw(a[this.value.length], t) : super._appendCharRaw(e, t);
  }
  doValidate(e) {
    const t = this.value;
    if (t.search(/[^0]/) === -1 && t.length <= this._matchFrom)
      return !0;
    const [a, n] = this.boundaries(t);
    return this.from <= Number(n) && Number(a) <= this.to && super.doValidate(e);
  }
  pad(e) {
    const t = new c();
    if (this.value.length === this.maxLength)
      return t;
    const s = this.value, a = this.maxLength - this.value.length;
    if (a) {
      this.reset();
      for (let n = 0; n < a; ++n)
        t.aggregate(super._appendCharRaw("0", e));
      s.split("").forEach((n) => this._appendCharRaw(n));
    }
    return t;
  }
}
p.MaskedRange = U;
const Ne = "d{.}`m{.}`Y";
class B extends _ {
  static extractPatternOptions(e) {
    const {
      mask: t,
      pattern: s,
      ...a
    } = e;
    return {
      ...a,
      mask: I(t) ? t : s
    };
  }
  /** Pattern mask for date according to {@link MaskedDate#format} */
  /** Start date */
  /** End date */
  /** Format typed value to string */
  /** Parse string to get typed value */
  constructor(e) {
    super(B.extractPatternOptions({
      ...B.DEFAULTS,
      ...e
    }));
  }
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    const {
      mask: t,
      pattern: s,
      blocks: a,
      ...n
    } = {
      ...B.DEFAULTS,
      ...e
    }, u = Object.assign({}, B.GET_DEFAULT_BLOCKS());
    e.min && (u.Y.from = e.min.getFullYear()), e.max && (u.Y.to = e.max.getFullYear()), e.min && e.max && u.Y.from === u.Y.to && (u.m.from = e.min.getMonth() + 1, u.m.to = e.max.getMonth() + 1, u.m.from === u.m.to && (u.d.from = e.min.getDate(), u.d.to = e.max.getDate())), Object.assign(u, this.blocks, a), super._update({
      ...n,
      mask: I(t) ? t : s,
      blocks: u
    });
  }
  doValidate(e) {
    const t = this.date;
    return super.doValidate(e) && (!this.isComplete || this.isDateExist(this.value) && t != null && (this.min == null || this.min <= t) && (this.max == null || t <= this.max));
  }
  /** Checks if date is exists */
  isDateExist(e) {
    return this.format(this.parse(e, this), this).indexOf(e) >= 0;
  }
  /** Parsed Date */
  get date() {
    return this.typedValue;
  }
  set date(e) {
    this.typedValue = e;
  }
  get typedValue() {
    return this.isComplete ? super.typedValue : null;
  }
  set typedValue(e) {
    super.typedValue = e;
  }
  maskEquals(e) {
    return e === Date || super.maskEquals(e);
  }
  optionsIsChanged(e) {
    return super.optionsIsChanged(B.extractPatternOptions(e));
  }
}
B.GET_DEFAULT_BLOCKS = () => ({
  d: {
    mask: U,
    from: 1,
    to: 31,
    maxLength: 2
  },
  m: {
    mask: U,
    from: 1,
    to: 12,
    maxLength: 2
  },
  Y: {
    mask: U,
    from: 1900,
    to: 9999
  }
});
B.DEFAULTS = {
  ..._.DEFAULTS,
  mask: Date,
  pattern: Ne,
  format: (i, e) => {
    if (!i)
      return "";
    const t = String(i.getDate()).padStart(2, "0"), s = String(i.getMonth() + 1).padStart(2, "0"), a = i.getFullYear();
    return [t, s, a].join(".");
  },
  parse: (i, e) => {
    const [t, s, a] = i.split(".").map(Number);
    return new Date(a, s - 1, t);
  }
};
p.MaskedDate = B;
class j extends v {
  constructor(e) {
    super({
      ...j.DEFAULTS,
      ...e
    }), this.currentMask = void 0;
  }
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    super._update(e), "mask" in e && (this.exposeMask = void 0, this.compiledMasks = Array.isArray(e.mask) ? e.mask.map((t) => {
      const {
        expose: s,
        ...a
      } = O(t), n = b({
        overwrite: this._overwrite,
        eager: this._eager,
        skipInvalid: this._skipInvalid,
        ...a
      });
      return s && (this.exposeMask = n), n;
    }) : []);
  }
  _appendCharRaw(e, t) {
    t === void 0 && (t = {});
    const s = this._applyDispatch(e, t);
    return this.currentMask && s.aggregate(this.currentMask._appendChar(e, this.currentMaskFlags(t))), s;
  }
  _applyDispatch(e, t, s) {
    e === void 0 && (e = ""), t === void 0 && (t = {}), s === void 0 && (s = "");
    const a = t.tail && t._beforeTailState != null ? t._beforeTailState._value : this.value, n = this.rawInputValue, u = t.tail && t._beforeTailState != null ? t._beforeTailState._rawInputValue : n, r = n.slice(u.length), l = this.currentMask, o = new c(), d = l == null ? void 0 : l.state;
    return this.currentMask = this.doDispatch(e, {
      ...t
    }, s), this.currentMask && (this.currentMask !== l ? (this.currentMask.reset(), u && (this.currentMask.append(u, {
      raw: !0
    }), o.tailShift = this.currentMask.value.length - a.length), r && (o.tailShift += this.currentMask.append(r, {
      raw: !0,
      tail: !0
    }).tailShift)) : d && (this.currentMask.state = d)), o;
  }
  _appendPlaceholder() {
    const e = this._applyDispatch();
    return this.currentMask && e.aggregate(this.currentMask._appendPlaceholder()), e;
  }
  _appendEager() {
    const e = this._applyDispatch();
    return this.currentMask && e.aggregate(this.currentMask._appendEager()), e;
  }
  appendTail(e) {
    const t = new c();
    return e && t.aggregate(this._applyDispatch("", {}, e)), t.aggregate(this.currentMask ? this.currentMask.appendTail(e) : super.appendTail(e));
  }
  currentMaskFlags(e) {
    var t, s;
    return {
      ...e,
      _beforeTailState: ((t = e._beforeTailState) == null ? void 0 : t.currentMaskRef) === this.currentMask && ((s = e._beforeTailState) == null ? void 0 : s.currentMask) || e._beforeTailState
    };
  }
  doDispatch(e, t, s) {
    return t === void 0 && (t = {}), s === void 0 && (s = ""), this.dispatch(e, this, t, s);
  }
  doValidate(e) {
    return super.doValidate(e) && (!this.currentMask || this.currentMask.doValidate(this.currentMaskFlags(e)));
  }
  doPrepare(e, t) {
    t === void 0 && (t = {});
    let [s, a] = super.doPrepare(e, t);
    if (this.currentMask) {
      let n;
      [s, n] = super.doPrepare(s, this.currentMaskFlags(t)), a = a.aggregate(n);
    }
    return [s, a];
  }
  doPrepareChar(e, t) {
    t === void 0 && (t = {});
    let [s, a] = super.doPrepareChar(e, t);
    if (this.currentMask) {
      let n;
      [s, n] = super.doPrepareChar(s, this.currentMaskFlags(t)), a = a.aggregate(n);
    }
    return [s, a];
  }
  reset() {
    var e;
    (e = this.currentMask) == null || e.reset(), this.compiledMasks.forEach((t) => t.reset());
  }
  get value() {
    return this.exposeMask ? this.exposeMask.value : this.currentMask ? this.currentMask.value : "";
  }
  set value(e) {
    this.exposeMask ? (this.exposeMask.value = e, this.currentMask = this.exposeMask, this._applyDispatch()) : super.value = e;
  }
  get unmaskedValue() {
    return this.exposeMask ? this.exposeMask.unmaskedValue : this.currentMask ? this.currentMask.unmaskedValue : "";
  }
  set unmaskedValue(e) {
    this.exposeMask ? (this.exposeMask.unmaskedValue = e, this.currentMask = this.exposeMask, this._applyDispatch()) : super.unmaskedValue = e;
  }
  get typedValue() {
    return this.exposeMask ? this.exposeMask.typedValue : this.currentMask ? this.currentMask.typedValue : "";
  }
  set typedValue(e) {
    if (this.exposeMask) {
      this.exposeMask.typedValue = e, this.currentMask = this.exposeMask, this._applyDispatch();
      return;
    }
    let t = String(e);
    this.currentMask && (this.currentMask.typedValue = e, t = this.currentMask.unmaskedValue), this.unmaskedValue = t;
  }
  get displayValue() {
    return this.currentMask ? this.currentMask.displayValue : "";
  }
  get isComplete() {
    var e;
    return !!((e = this.currentMask) != null && e.isComplete);
  }
  get isFilled() {
    var e;
    return !!((e = this.currentMask) != null && e.isFilled);
  }
  remove(e, t) {
    const s = new c();
    return this.currentMask && s.aggregate(this.currentMask.remove(e, t)).aggregate(this._applyDispatch()), s;
  }
  get state() {
    var e;
    return {
      ...super.state,
      _rawInputValue: this.rawInputValue,
      compiledMasks: this.compiledMasks.map((t) => t.state),
      currentMaskRef: this.currentMask,
      currentMask: (e = this.currentMask) == null ? void 0 : e.state
    };
  }
  set state(e) {
    const {
      compiledMasks: t,
      currentMaskRef: s,
      currentMask: a,
      ...n
    } = e;
    t && this.compiledMasks.forEach((u, r) => u.state = t[r]), s != null && (this.currentMask = s, this.currentMask.state = a), super.state = n;
  }
  extractInput(e, t, s) {
    return this.currentMask ? this.currentMask.extractInput(e, t, s) : "";
  }
  extractTail(e, t) {
    return this.currentMask ? this.currentMask.extractTail(e, t) : super.extractTail(e, t);
  }
  doCommit() {
    this.currentMask && this.currentMask.doCommit(), super.doCommit();
  }
  nearestInputPos(e, t) {
    return this.currentMask ? this.currentMask.nearestInputPos(e, t) : super.nearestInputPos(e, t);
  }
  get overwrite() {
    return this.currentMask ? this.currentMask.overwrite : this._overwrite;
  }
  set overwrite(e) {
    this._overwrite = e;
  }
  get eager() {
    return this.currentMask ? this.currentMask.eager : this._eager;
  }
  set eager(e) {
    this._eager = e;
  }
  get skipInvalid() {
    return this.currentMask ? this.currentMask.skipInvalid : this._skipInvalid;
  }
  set skipInvalid(e) {
    this._skipInvalid = e;
  }
  get autofix() {
    return this.currentMask ? this.currentMask.autofix : this._autofix;
  }
  set autofix(e) {
    this._autofix = e;
  }
  maskEquals(e) {
    return Array.isArray(e) ? this.compiledMasks.every((t, s) => {
      if (!e[s])
        return;
      const {
        mask: a,
        ...n
      } = e[s];
      return P(t, n) && t.maskEquals(a);
    }) : super.maskEquals(e);
  }
  typedValueEquals(e) {
    var t;
    return !!((t = this.currentMask) != null && t.typedValueEquals(e));
  }
}
j.DEFAULTS = {
  ...v.DEFAULTS,
  dispatch: (i, e, t, s) => {
    if (!e.compiledMasks.length)
      return;
    const a = e.rawInputValue, n = e.compiledMasks.map((u, r) => {
      const l = e.currentMask === u, o = l ? u.displayValue.length : u.nearestInputPos(u.displayValue.length, h.FORCE_LEFT);
      return u.rawInputValue !== a ? (u.reset(), u.append(a, {
        raw: !0
      })) : l || u.remove(o), u.append(i, e.currentMaskFlags(t)), u.appendTail(s), {
        index: r,
        weight: u.rawInputValue.length,
        totalInputPositions: u.totalInputPositions(0, Math.max(o, u.nearestInputPos(u.displayValue.length, h.FORCE_LEFT)))
      };
    });
    return n.sort((u, r) => r.weight - u.weight || r.totalInputPositions - u.totalInputPositions), e.compiledMasks[n[0].index];
  }
};
p.MaskedDynamic = j;
class K extends _ {
  constructor(e) {
    super({
      ...K.DEFAULTS,
      ...e
    });
  }
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    const {
      enum: t,
      ...s
    } = e;
    if (t) {
      const a = t.map((r) => r.length), n = Math.min(...a), u = Math.max(...a) - n;
      s.mask = "*".repeat(n), u && (s.mask += "[" + "*".repeat(u) + "]"), this.enum = t;
    }
    super._update(s);
  }
  _appendCharRaw(e, t) {
    t === void 0 && (t = {});
    const s = Math.min(this.nearestInputPos(0, h.FORCE_RIGHT), this.value.length), a = this.enum.filter((n) => this.matchValue(n, this.unmaskedValue + e, s));
    if (a.length) {
      a.length === 1 && this._forEachBlocksInRange(0, this.value.length, (u, r) => {
        const l = a[0][r];
        r >= this.value.length || l === u.value || (u.reset(), u._appendChar(l, t));
      });
      const n = super._appendCharRaw(a[0][this.value.length], t);
      return a.length === 1 && a[0].slice(this.unmaskedValue.length).split("").forEach((u) => n.aggregate(super._appendCharRaw(u))), n;
    }
    return new c({
      skip: !this.isComplete
    });
  }
  extractTail(e, t) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), new S("", e);
  }
  remove(e, t) {
    if (e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), e === t)
      return new c();
    const s = Math.min(super.nearestInputPos(0, h.FORCE_RIGHT), this.value.length);
    let a;
    for (a = e; a >= 0 && !(this.enum.filter((r) => this.matchValue(r, this.value.slice(s, a), s)).length > 1); --a)
      ;
    const n = super.remove(a, t);
    return n.tailShift += a - e, n;
  }
  get isComplete() {
    return this.enum.indexOf(this.value) >= 0;
  }
}
K.DEFAULTS = {
  ..._.DEFAULTS,
  matchValue: (i, e, t) => i.indexOf(e, t) === t
};
p.MaskedEnum = K;
class Ue extends v {
  /** */
  /** Enable characters overwriting */
  /** */
  /** */
  /** */
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    super._update({
      ...e,
      validate: e.mask
    });
  }
}
p.MaskedFunction = Ue;
var me;
class E extends v {
  /** Single char */
  /** Single char */
  /** Array of single chars */
  /** */
  /** */
  /** Digits after point */
  /** Flag to remove leading and trailing zeros in the end of editing */
  /** Flag to pad trailing zeros after point in the end of editing */
  /** Enable characters overwriting */
  /** */
  /** */
  /** */
  /** Format typed value to string */
  /** Parse string to get typed value */
  constructor(e) {
    super({
      ...E.DEFAULTS,
      ...e
    });
  }
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    super._update(e), this._updateRegExps();
  }
  _updateRegExps() {
    const e = "^" + (this.allowNegative ? "[+|\\-]?" : ""), t = "\\d*", s = (this.scale ? "(" + Z(this.radix) + "\\d{0," + this.scale + "})?" : "") + "$";
    this._numberRegExp = new RegExp(e + t + s), this._mapToRadixRegExp = new RegExp("[" + this.mapToRadix.map(Z).join("") + "]", "g"), this._thousandsSeparatorRegExp = new RegExp(Z(this.thousandsSeparator), "g");
  }
  _removeThousandsSeparators(e) {
    return e.replace(this._thousandsSeparatorRegExp, "");
  }
  _insertThousandsSeparators(e) {
    const t = e.split(this.radix);
    return t[0] = t[0].replace(/\B(?=(\d{3})+(?!\d))/g, this.thousandsSeparator), t.join(this.radix);
  }
  doPrepareChar(e, t) {
    t === void 0 && (t = {});
    const [s, a] = super.doPrepareChar(this._removeThousandsSeparators(this.scale && this.mapToRadix.length && /*
      radix should be mapped when
      1) input is done from keyboard = flags.input && flags.raw
      2) unmasked value is set = !flags.input && !flags.raw
      and should not be mapped when
      1) value is set = flags.input && !flags.raw
      2) raw value is set = !flags.input && flags.raw
    */
    (t.input && t.raw || !t.input && !t.raw) ? e.replace(this._mapToRadixRegExp, this.radix) : e), t);
    return e && !s && (a.skip = !0), s && !this.allowPositive && !this.value && s !== "-" && a.aggregate(this._appendChar("-")), [s, a];
  }
  _separatorsCount(e, t) {
    t === void 0 && (t = !1);
    let s = 0;
    for (let a = 0; a < e; ++a)
      this._value.indexOf(this.thousandsSeparator, a) === a && (++s, t && (e += this.thousandsSeparator.length));
    return s;
  }
  _separatorsCountFromSlice(e) {
    return e === void 0 && (e = this._value), this._separatorsCount(this._removeThousandsSeparators(e).length, !0);
  }
  extractInput(e, t, s) {
    return e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), [e, t] = this._adjustRangeWithSeparators(e, t), this._removeThousandsSeparators(super.extractInput(e, t, s));
  }
  _appendCharRaw(e, t) {
    t === void 0 && (t = {});
    const s = t.tail && t._beforeTailState ? t._beforeTailState._value : this._value, a = this._separatorsCountFromSlice(s);
    this._value = this._removeThousandsSeparators(this.value);
    const n = this._value;
    this._value += e;
    const u = this.number;
    let r = !isNaN(u), l = !1;
    if (r) {
      let k;
      this.min != null && this.min < 0 && this.number < this.min && (k = this.min), this.max != null && this.max > 0 && this.number > this.max && (k = this.max), k != null && (this.autofix ? (this._value = this.format(k, this).replace(E.UNMASKED_RADIX, this.radix), l || (l = n === this._value && !t.tail)) : r = !1), r && (r = !!this._value.match(this._numberRegExp));
    }
    let o;
    r ? o = new c({
      inserted: this._value.slice(n.length),
      rawInserted: l ? "" : e,
      skip: l
    }) : (this._value = n, o = new c()), this._value = this._insertThousandsSeparators(this._value);
    const d = t.tail && t._beforeTailState ? t._beforeTailState._value : this._value, m = this._separatorsCountFromSlice(d);
    return o.tailShift += (m - a) * this.thousandsSeparator.length, o;
  }
  _findSeparatorAround(e) {
    if (this.thousandsSeparator) {
      const t = e - this.thousandsSeparator.length + 1, s = this.value.indexOf(this.thousandsSeparator, t);
      if (s <= e)
        return s;
    }
    return -1;
  }
  _adjustRangeWithSeparators(e, t) {
    const s = this._findSeparatorAround(e);
    s >= 0 && (e = s);
    const a = this._findSeparatorAround(t);
    return a >= 0 && (t = a + this.thousandsSeparator.length), [e, t];
  }
  remove(e, t) {
    e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length), [e, t] = this._adjustRangeWithSeparators(e, t);
    const s = this.value.slice(0, e), a = this.value.slice(t), n = this._separatorsCount(s.length);
    this._value = this._insertThousandsSeparators(this._removeThousandsSeparators(s + a));
    const u = this._separatorsCountFromSlice(s);
    return new c({
      tailShift: (u - n) * this.thousandsSeparator.length
    });
  }
  nearestInputPos(e, t) {
    if (!this.thousandsSeparator)
      return e;
    switch (t) {
      case h.NONE:
      case h.LEFT:
      case h.FORCE_LEFT: {
        const s = this._findSeparatorAround(e - 1);
        if (s >= 0) {
          const a = s + this.thousandsSeparator.length;
          if (e < a || this.value.length <= a || t === h.FORCE_LEFT)
            return s;
        }
        break;
      }
      case h.RIGHT:
      case h.FORCE_RIGHT: {
        const s = this._findSeparatorAround(e);
        if (s >= 0)
          return s + this.thousandsSeparator.length;
      }
    }
    return e;
  }
  doCommit() {
    if (this.value) {
      const e = this.number;
      let t = e;
      this.min != null && (t = Math.max(t, this.min)), this.max != null && (t = Math.min(t, this.max)), t !== e && (this.unmaskedValue = this.format(t, this));
      let s = this.value;
      this.normalizeZeros && (s = this._normalizeZeros(s)), this.padFractionalZeros && this.scale > 0 && (s = this._padFractionalZeros(s)), this._value = s;
    }
    super.doCommit();
  }
  _normalizeZeros(e) {
    const t = this._removeThousandsSeparators(e).split(this.radix);
    return t[0] = t[0].replace(/^(\D*)(0*)(\d*)/, (s, a, n, u) => a + u), e.length && !/\d$/.test(t[0]) && (t[0] = t[0] + "0"), t.length > 1 && (t[1] = t[1].replace(/0*$/, ""), t[1].length || (t.length = 1)), this._insertThousandsSeparators(t.join(this.radix));
  }
  _padFractionalZeros(e) {
    if (!e)
      return e;
    const t = e.split(this.radix);
    return t.length < 2 && t.push(""), t[1] = t[1].padEnd(this.scale, "0"), t.join(this.radix);
  }
  doSkipInvalid(e, t, s) {
    t === void 0 && (t = {});
    const a = this.scale === 0 && e !== this.thousandsSeparator && (e === this.radix || e === E.UNMASKED_RADIX || this.mapToRadix.includes(e));
    return super.doSkipInvalid(e, t, s) && !a;
  }
  get unmaskedValue() {
    return this._removeThousandsSeparators(this._normalizeZeros(this.value)).replace(this.radix, E.UNMASKED_RADIX);
  }
  set unmaskedValue(e) {
    super.unmaskedValue = e;
  }
  get typedValue() {
    return this.parse(this.unmaskedValue, this);
  }
  set typedValue(e) {
    this.rawInputValue = this.format(e, this).replace(E.UNMASKED_RADIX, this.radix);
  }
  /** Parsed Number */
  get number() {
    return this.typedValue;
  }
  set number(e) {
    this.typedValue = e;
  }
  get allowNegative() {
    return this.min != null && this.min < 0 || this.max != null && this.max < 0;
  }
  get allowPositive() {
    return this.min != null && this.min > 0 || this.max != null && this.max > 0;
  }
  typedValueEquals(e) {
    return (super.typedValueEquals(e) || E.EMPTY_VALUES.includes(e) && E.EMPTY_VALUES.includes(this.typedValue)) && !(e === 0 && this.value === "");
  }
}
me = E;
E.UNMASKED_RADIX = ".";
E.EMPTY_VALUES = [...v.EMPTY_VALUES, 0];
E.DEFAULTS = {
  ...v.DEFAULTS,
  mask: Number,
  radix: ",",
  thousandsSeparator: "",
  mapToRadix: [me.UNMASKED_RADIX],
  min: Number.MIN_SAFE_INTEGER,
  max: Number.MAX_SAFE_INTEGER,
  scale: 2,
  normalizeZeros: !0,
  padFractionalZeros: !1,
  parse: Number,
  format: (i) => i.toLocaleString("en-US", {
    useGrouping: !1,
    maximumFractionDigits: 20
  })
};
p.MaskedNumber = E;
const X = {
  MASKED: "value",
  UNMASKED: "unmaskedValue",
  TYPED: "typedValue"
};
function ke(i, e, t) {
  e === void 0 && (e = X.MASKED), t === void 0 && (t = X.MASKED);
  const s = b(i);
  return (a) => s.runIsolated((n) => (n[e] = a, n[t]));
}
function Pe(i, e, t, s) {
  return ke(e, t, s)(i);
}
p.PIPE_TYPE = X;
p.createPipe = ke;
p.pipe = Pe;
class qe extends _ {
  get repeatFrom() {
    var e;
    return (e = Array.isArray(this.repeat) ? this.repeat[0] : this.repeat === 1 / 0 ? 0 : this.repeat) != null ? e : 0;
  }
  get repeatTo() {
    var e;
    return (e = Array.isArray(this.repeat) ? this.repeat[1] : this.repeat) != null ? e : 1 / 0;
  }
  constructor(e) {
    super(e);
  }
  updateOptions(e) {
    super.updateOptions(e);
  }
  _update(e) {
    var t, s, a;
    const {
      repeat: n,
      ...u
    } = O(e);
    this._blockOpts = Object.assign({}, this._blockOpts, u);
    const r = b(this._blockOpts);
    this.repeat = (t = (s = n ?? r.repeat) != null ? s : this.repeat) != null ? t : 1 / 0, super._update({
      mask: "m".repeat(Math.max(this.repeatTo === 1 / 0 && ((a = this._blocks) == null ? void 0 : a.length) || 0, this.repeatFrom)),
      blocks: {
        m: r
      },
      eager: r.eager,
      overwrite: r.overwrite,
      skipInvalid: r.skipInvalid,
      lazy: r.lazy,
      placeholderChar: r.placeholderChar,
      displayChar: r.displayChar
    });
  }
  _allocateBlock(e) {
    if (e < this._blocks.length)
      return this._blocks[e];
    if (this.repeatTo === 1 / 0 || this._blocks.length < this.repeatTo)
      return this._blocks.push(b(this._blockOpts)), this.mask += "m", this._blocks[this._blocks.length - 1];
  }
  _appendCharRaw(e, t) {
    t === void 0 && (t = {});
    const s = new c();
    for (
      let l = (a = (n = this._mapPosToBlock(this.displayValue.length)) == null ? void 0 : n.index) != null ? a : Math.max(this._blocks.length - 1, 0), o, d;
      // try to get a block or
      // try to allocate a new block if not allocated already
      o = (u = this._blocks[l]) != null ? u : d = !d && this._allocateBlock(l);
      ++l
    ) {
      var a, n, u, r;
      const m = o._appendChar(e, {
        ...t,
        _beforeTailState: (r = t._beforeTailState) == null || (r = r._blocks) == null ? void 0 : r[l]
      });
      if (m.skip && d) {
        this._blocks.pop(), this.mask = this.mask.slice(1);
        break;
      }
      if (s.aggregate(m), m.consumed)
        break;
    }
    return s;
  }
  _trimEmptyTail(e, t) {
    var s, a;
    e === void 0 && (e = 0);
    const n = Math.max(((s = this._mapPosToBlock(e)) == null ? void 0 : s.index) || 0, this.repeatFrom, 0);
    let u;
    t != null && (u = (a = this._mapPosToBlock(t)) == null ? void 0 : a.index), u == null && (u = this._blocks.length - 1);
    let r = 0;
    for (let l = u; n <= l && !this._blocks[l].unmaskedValue; --l, ++r)
      ;
    r && (this._blocks.splice(u - r + 1, r), this.mask = this.mask.slice(r));
  }
  reset() {
    super.reset(), this._trimEmptyTail();
  }
  remove(e, t) {
    e === void 0 && (e = 0), t === void 0 && (t = this.displayValue.length);
    const s = super.remove(e, t);
    return this._trimEmptyTail(e, t), s;
  }
  totalInputPositions(e, t) {
    return e === void 0 && (e = 0), t == null && this.repeatTo === 1 / 0 ? 1 / 0 : super.totalInputPositions(e, t);
  }
  get state() {
    return super.state;
  }
  set state(e) {
    this._blocks.length = e._blocks.length, this.mask = this.mask.slice(0, this._blocks.length), super.state = e;
  }
}
p.RepeatBlock = qe;
try {
  globalThis.IMask = p;
} catch {
}
var $e = {
  // common
  mask: void 0,
  prepare: Function,
  prepareChar: Function,
  validate: Function,
  commit: Function,
  overwrite: {
    type: Boolean,
    required: !1,
    default: void 0
  },
  eager: {
    required: !1,
    default: void 0,
    validator: (i) => ["append", "remove"].includes(i) || typeof i == "boolean"
  },
  skipInvalid: {
    type: Boolean,
    required: !1,
    default: void 0
  },
  // pattern
  placeholderChar: String,
  displayChar: String,
  lazy: {
    type: Boolean,
    required: !1,
    default: void 0
  },
  definitions: Object,
  blocks: Object,
  // enum
  enum: Array,
  // range
  maxLength: Number,
  from: Number,
  to: Number,
  // date
  pattern: String,
  format: Function,
  parse: Function,
  autofix: {
    required: !1,
    default: void 0,
    validator: (i) => i === "pad" || typeof i == "boolean"
  },
  // number
  radix: String,
  thousandsSeparator: String,
  mapToRadix: Array,
  scale: Number,
  normalizeZeros: {
    type: Boolean,
    required: !1,
    default: void 0
  },
  padFractionalZeros: {
    type: Boolean,
    required: !1,
    default: void 0
  },
  min: [Number, Date],
  max: [Number, Date],
  // dynamic
  dispatch: Function
};
function He(i, e) {
  let {
    emit: t,
    onAccept: s,
    onComplete: a,
    defaultValue: n,
    defaultUnmaskedValue: u,
    defaultTypedValue: r
  } = e === void 0 ? {} : e;
  const l = ve(i) ? i : M(i), o = M(), d = M(), m = M(""), k = M(""), f = M();
  let C, w = m.value, D = k.value, z = f.value;
  function J() {
    z = f.value = d.value.typedValue, D = k.value = d.value.unmaskedValue, w = m.value = d.value.value;
  }
  function L(g) {
    J(), t && (t("accept", m.value, g), t("accept:masked", m.value, g), t("accept:typed", f.value, g), t("accept:unmasked", k.value, g)), s == null || s(g);
  }
  function ge(g) {
    t && (t("complete", d.value.value, g), t("complete:masked", d.value.value, g), t("complete:typed", d.value.typedValue, g), t("complete:unmasked", d.value.unmaskedValue, g)), a == null || a(g);
  }
  const Q = () => {
    !d.value || k.value === void 0 || (D !== k.value && (d.value.unmaskedValue = k.value, d.value.unmaskedValue !== k.value && L()), D = void 0);
  };
  V(k, Q);
  const ee = () => {
    !d.value || m.value === void 0 || (w !== m.value && (d.value.value = m.value, d.value.value !== m.value && L()), w = void 0);
  };
  V(m, ee);
  const te = () => {
    !d.value || f.value === void 0 || (z !== f.value && (d.value.typedValue = f.value, d.value.masked.typedValueEquals(f.value) || L()), z = void 0);
  };
  V(f, te);
  function se() {
    C = o.value;
    const g = l.value;
    !C || !(g != null && g.mask) || (d.value = p(C, g), n !== void 0 && (m.value = n), u !== void 0 && (k.value = u), r !== void 0 && (f.value = r), Q(), ee(), te(), J(), d.value.on("accept", L).on("complete", ge));
  }
  function ie() {
    var g;
    (g = d.value) == null || g.destroy(), d.value = void 0;
  }
  return _e(se), Ce(ie), V([o, l], () => {
    const g = o.value, G = l.value;
    (!(G != null && G.mask) || g !== C) && ie(), g && (d.value ? d.value.updateOptions(G) : se());
  }), {
    el: o,
    mask: Ee(d),
    masked: m,
    unmasked: k,
    typed: f
  };
}
function je(i, e) {
  return i = {
    ...i
  }, Object.keys(i).forEach((t) => {
    (i[t] === void 0 || e.includes(t)) && delete i[t];
  }), i;
}
const Ke = ["typed", "unmasked", "value", "modelValue"];
var ze = he({
  name: "imask-input",
  inheritAttrs: !1,
  props: {
    // plugin
    modelValue: String,
    value: String,
    unmasked: String,
    typed: {
      validator: () => !0
    },
    ...$e
  },
  emits: ["update:modelValue", "update:masked", "update:value", "update:unmasked", "update:typed", "accept", "accept:value", "accept:masked", "accept:unmasked", "accept:typed", "complete", "complete:value", "complete:masked", "complete:unmasked", "complete:typed"],
  setup(i, e) {
    let {
      attrs: t,
      emit: s
    } = e;
    const {
      el: a,
      mask: n,
      masked: u,
      unmasked: r,
      typed: l
    } = He(je(i, Ke), {
      emit: s,
      onAccept: (f) => {
        const C = u.value;
        s("accept:value", C, f), s("update:value", C, f), s("update:masked", C, f), s("update:modelValue", C, f), s("update:unmasked", r.value, f), s("update:typed", l.value, f);
      },
      onComplete: (f) => {
        s("complete:value", u.value, f);
      }
    }), o = N(i, "value"), d = N(i, "modelValue"), m = N(i, "unmasked"), k = N(i, "typed");
    return u.value = d.value || o.value || "", r.value = m.value || "", l.value = k.value, V(o, (f) => u.value = f), V(d, (f) => u.value = f), V(m, (f) => r.value = f), V(k, (f) => l.value = f), () => {
      const f = {
        ...t,
        value: i.value != null ? i.value : i.modelValue != null ? i.modelValue : n.value ? n.value.displayValue : "",
        ref: a
      };
      return i.mask || (f.onInput = (C) => {
        s("update:modelValue", C.target.value), s("update:value", C.target.value);
      }), Fe("input", f);
    };
  }
}), Ge = ze;
const Ye = he({
  emits: {
    "update:modelValue": (i) => !0,
    blur: (i) => !0,
    change: (i) => !0,
    focus: (i) => !0,
    input: (i) => !0,
    keydown: (i) => !0
  },
  props: {
    autocomplete: {
      required: !1,
      type: Boolean
    },
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    icon: {
      required: !1,
      type: Object
    },
    invalidNumberMessage: {
      default: "Please enter valid numbers",
      type: String
    },
    isError: {
      required: !1,
      type: Boolean
    },
    isFocus: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    max: {
      required: !1,
      type: Number
    },
    maxDecimalPlaces: {
      default: 10,
      type: Number
    },
    min: {
      required: !1,
      type: Number
    },
    modelValue: {
      required: !1,
      type: null
    },
    numberLocale: {
      default: "en-US",
      type: String
    },
    placeholder: {
      required: !1,
      type: String
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    step: {
      default: 1,
      type: Number
    },
    tabindex: {
      required: !1,
      type: Number
    },
    textAlign: {
      default: "left",
      type: String
    },
    value: {
      required: !1,
      type: null
    },
    variant: {
      default: "default",
      required: !1,
      type: String
    },
    withLocale: {
      default: !1,
      type: Boolean
    }
  },
  name: "sb-form-input",
  components: {
    "imask-input": Ge
  },
  data() {
    return {
      localIsFocus: !1,
      isInvalidNumber: !1,
      localValue: this.modelValue ?? this.value ?? ""
    };
  },
  computed: {
    getRadix() {
      return this.withLocale && this.numberLocale === "id-ID" ? "," : ".";
    },
    getThousandsSeparator() {
      return this.withLocale && this.numberLocale === "id-ID" ? "." : ",";
    },
    iconSortDown() {
      return Ve();
    },
    iconSortUp() {
      return Ie();
    },
    isFilled() {
      var i;
      return this.localValue !== null && typeof this.localValue < "u" ? typeof this.localValue != "number" ? this.localValue !== "" || ((i = this.localValue) == null ? void 0 : i.length) || Object.keys(this.localValue).length > 0 : !0 : !1;
    }
  },
  methods: {
    handleBlur(i) {
      this.localIsFocus = !1, i.target.value = this.localValue, this.$emit("blur", i);
    },
    handleChange(i) {
      i.target.value = this.localValue, this.$emit("change", i);
    },
    handleClickIcon(i) {
      var e;
      return ((e = this.icon) == null ? void 0 : e.onClick) && this.icon.onClick(i);
    },
    handleClickOutsideInput(i) {
      const e = i.target, t = this.$refs["input-wrapper"];
      e && t && !t.contains(e) && !e.isSameNode(t) && this.toggleFocus(!1);
    },
    handleClickStep(i) {
      const e = Number(this.localValue), t = Number.isNaN(e) ? 0 : e + i;
      e > 0 && e < 1 && t < 0 ? this.localValue = 0 : typeof this.max < "u" && t > this.max ? this.localValue = this.max : typeof this.min < "u" && t < this.min ? this.localValue = this.min : this.localValue = t;
    },
    handleComplete(i) {
      this.$emit("input", {
        target: {
          value: i
        }
      }), this.$emit("update:modelValue", i);
    },
    handleErrorMessage() {
      return this.errorMessage ? typeof this.errorMessage == "string" ? this.errorMessage : this.errorMessage(this.localValue) : "";
    },
    handleInputFocus(i) {
      this.localIsFocus = !0, this.$emit("focus", i);
    },
    handleKeydown(i) {
      !this.maxDecimalPlaces && (i.key === "," || i.key === ".") ? (i.preventDefault(), i.stopPropagation()) : i.key === "ArrowUp" ? (i.preventDefault(), i.stopPropagation(), this.handleClickStep(this.step)) : i.key === "ArrowDown" && (i.preventDefault(), i.stopPropagation(), this.handleClickStep(this.step * -1)), this.$emit("keydown", i);
    },
    handleMouseLeaveIcon(i) {
      var e;
      return ((e = this.icon) == null ? void 0 : e.onMouseLeave) && this.icon.onMouseLeave(i);
    },
    handleMouseOverIcon(i) {
      var e;
      return ((e = this.icon) == null ? void 0 : e.onMouseOver) && this.icon.onMouseOver(i);
    },
    handlePaste(i) {
      const t = (i.clipboardData || window.clipboardData).getData("Text");
      /^-?\d*[.,]?\d*$/.test(t) || i.preventDefault();
    },
    toggleFocus(i, e) {
      if (e) {
        const t = e.target, s = t == null ? void 0 : t.querySelectorAll("input");
        s.length > 0 && s[0].focus();
      }
      this.localIsFocus = i;
    }
  },
  watch: {
    isFocus(i) {
      this.localIsFocus = i;
    },
    modelValue(i) {
      this.localValue = i || "";
    },
    value(i) {
      this.localValue = i || "";
    }
  },
  mounted() {
    document.addEventListener(
      "click",
      (i) => this.handleClickOutsideInput(i)
    );
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (i) => this.handleClickOutsideInput(i)
    );
  }
});
const Ze = {
  key: 0,
  class: "asterisk"
}, Xe = { class: "button-wrapper" }, We = { class: "input-border" }, Je = { class: "notch" }, Qe = {
  key: 0,
  class: "asterisk"
}, et = {
  key: 0,
  class: "error-wrapper"
}, tt = { key: 0 }, st = ["innerHTML"];
function it(i, e, t, s, a, n) {
  var r;
  const u = Ae("imask-input");
  return F(), A("div", ae({
    class: ["input-wrapper number", { error: i.isError, flat: i.variant === "flat" }],
    ref: "input-wrapper"
  }, { ...i.$attrs }), [
    y("div", {
      class: T(["input-group", {
        disabled: i.disabled,
        filled: i.isFilled,
        focus: i.isFocus || i.localIsFocus,
        icon_prepend: !!i.icon || !!i.$slots["icon-slot"],
        readonly: i.readOnly
      }])
    }, [
      i.label ? (F(), A("label", {
        key: 0,
        class: T(["label", { required: i.required }])
      }, [
        y("span", null, Y(i.label), 1),
        i.required ? (F(), A("span", Ze, "*")) : R("", !0)
      ], 2)) : R("", !0),
      i.icon || i.$slots["icon-slot"] ? (F(), A("span", {
        key: 1,
        class: T([{
          "sb-cursor-pointer": (r = i.icon) == null ? void 0 : r.onClick
        }, "icon"]),
        onClick: e[0] || (e[0] = ye((...l) => i.handleClickIcon && i.handleClickIcon(...l), ["stop"])),
        onMouseover: e[1] || (e[1] = (...l) => i.handleMouseOverIcon && i.handleMouseOverIcon(...l)),
        onMouseleave: e[2] || (e[2] = (...l) => i.handleMouseLeaveIcon && i.handleMouseLeaveIcon(...l))
      }, [
        Se(i.$slots, "icon-slot")
      ], 34)) : R("", !0),
      y("div", {
        class: T(["form-control", ["text", i.textAlign]]),
        onClick: e[4] || (e[4] = (l) => i.toggleFocus(!0, l))
      }, [
        Be(u, ae({
          unmask: "",
          autocomplete: i.autocomplete ? "on" : "off",
          "map-to-radix": ["."],
          mask: Number,
          max: i.max ?? 1 / 0,
          min: i.min ?? -1 / 0,
          radix: i.getRadix,
          scale: i.maxDecimalPlaces ?? 0,
          tabindex: i.readOnly || i.disabled ? -1 : i.tabindex,
          "thousands-separator": i.getThousandsSeparator,
          typed: i.localValue,
          "onUpdate:typed": e[3] || (e[3] = (l) => i.localValue = l),
          type: "text"
        }, {
          disabled: i.disabled,
          placeholder: i.placeholder,
          readonly: i.readOnly
        }, {
          onBlur: i.handleBlur,
          onChange: i.handleChange,
          "onComplete:typed": i.handleComplete,
          onFocus: i.handleInputFocus,
          onKeydown: i.handleKeydown,
          onPaste: i.handlePaste
        }), null, 16, ["autocomplete", "map-to-radix", "max", "min", "radix", "scale", "tabindex", "thousands-separator", "typed", "onBlur", "onChange", "onComplete:typed", "onFocus", "onKeydown", "onPaste"])
      ], 2),
      y("div", Xe, [
        y("div", {
          class: "button increment",
          onClick: e[5] || (e[5] = (l) => i.handleClickStep(i.step))
        }, [
          (F(), ne(ue(i.iconSortUp)))
        ]),
        y("div", {
          class: "button decrement",
          onClick: e[6] || (e[6] = (l) => i.handleClickStep(i.step * -1))
        }, [
          (F(), ne(ue(i.iconSortDown)))
        ])
      ]),
      y("fieldset", We, [
        y("legend", Je, [
          y("span", {
            class: T(["notch-label", { "no-label": !i.label || i.label === "" }])
          }, [
            i.label && i.label !== "" ? (F(), A(re, { key: 0 }, [
              y("span", null, Y(i.label), 1),
              i.required ? (F(), A("span", Qe, "*")) : R("", !0)
            ], 64)) : (F(), A(re, { key: 1 }, [
              be("​")
            ], 64))
          ], 2)
        ])
      ])
    ], 2),
    i.isInvalidNumber || i.isError && i.errorMessage ? (F(), A("div", et, [
      i.isInvalidNumber ? (F(), A("span", tt, Y(i.invalidNumberMessage), 1)) : (F(), A("span", {
        key: 1,
        innerHTML: i.handleErrorMessage()
      }, null, 8, st))
    ])) : R("", !0)
  ], 16);
}
const rt = /* @__PURE__ */ De(Ye, [["render", it]]);
export {
  rt as default
};
