import { PropType } from 'vue';
import { IOrganizationTreeItem } from '../../interface';
import { ICanvasState, IConnection, IConnectorState, IDraggedItem, IPointTarget, ISelectedConnection } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    canvasState: {
        required: true;
        type: PropType<ICanvasState>;
    };
    connectorState: {
        required: true;
        type: PropType<IConnectorState>;
    };
    isDragged: {
        required: false;
        type: BooleanConstructor;
    };
    isSelected: {
        required: false;
        type: BooleanConstructor;
    };
    isEditable: {
        required: false;
        type: BooleanConstructor;
    };
    item: {
        required: true;
        type: PropType<IOrganizationTreeItem>;
    };
    selectedConnection: {
        required: false;
        type: PropType<ISelectedConnection | null>;
    };
}, unknown, {
    connectionsPath: Record<string, any>;
}, {
    getItemPosition(): {
        left: string | number;
        top: string | number;
    };
    isConnecting(): boolean;
}, {
    getConnectionPath(connection: IConnection): string | undefined;
    getConnectionPathString(connection: IConnection): any;
    getCoordinatesMove(ev: MouseEvent | TouchEvent): {
        x: number;
        y: number;
    };
    handleCircleDoubleClick(indexConnection: number, indexCircle: number): void;
    handleClickIO(ev: MouseEvent | TouchEvent, targetIO: number): void;
    handleClickPoint(ev: MouseEvent | TouchEvent, indexConnection: number, indexPoint: number): void;
    handleConnectionClick(ev: MouseEvent, index: number): void;
    handleConnectionDoubleClick(ev: MouseEvent, index: number): void;
    handleInitConnections(): void;
    handleItemClick(ev: MouseEvent | TouchEvent): void;
    isConnectionSelected(index: number): boolean;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    changePoint: (_item: IOrganizationTreeItem, _index: number) => true;
    clickItem: (_item: IOrganizationTreeItem, _index: number) => true;
    dragItem: (_item: IDraggedItem) => true;
    dragConnection: (_io: string, _fromRect: DOMRect) => true;
    dragPoint: (_target: IPointTarget, _fromRect: DOMRect) => true;
    selectConnection: (_connection: ISelectedConnection) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    canvasState: {
        required: true;
        type: PropType<ICanvasState>;
    };
    connectorState: {
        required: true;
        type: PropType<IConnectorState>;
    };
    isDragged: {
        required: false;
        type: BooleanConstructor;
    };
    isSelected: {
        required: false;
        type: BooleanConstructor;
    };
    isEditable: {
        required: false;
        type: BooleanConstructor;
    };
    item: {
        required: true;
        type: PropType<IOrganizationTreeItem>;
    };
    selectedConnection: {
        required: false;
        type: PropType<ISelectedConnection | null>;
    };
}>> & {
    onChangePoint?: ((_item: IOrganizationTreeItem, _index: number) => any) | undefined;
    onClickItem?: ((_item: IOrganizationTreeItem, _index: number) => any) | undefined;
    onDragItem?: ((_item: IDraggedItem) => any) | undefined;
    onDragConnection?: ((_io: string, _fromRect: DOMRect) => any) | undefined;
    onDragPoint?: ((_target: IPointTarget, _fromRect: DOMRect) => any) | undefined;
    onSelectConnection?: ((_connection: ISelectedConnection) => any) | undefined;
}, {
    isSelected: boolean;
    isDragged: boolean;
    isEditable: boolean;
}, {}>;
export default _default;
