import { PropType } from 'vue';
import { IOrganizationTreeItem } from '../../interface';
import { ICanvasState, IConnectorState, ICoordinates, IDraggedItem, IMouseState, IParentPointerState, IParentState, IPointState, IPointTarget, ISelectedConnection } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    isEditable: {
        required: false;
        type: BooleanConstructor;
    };
    list: {
        required: true;
        type: PropType<IOrganizationTreeItem[]>;
    };
}, unknown, {
    canvasState: ICanvasState;
    canvasStyle: Record<string, any>;
    connectorState: IConnectorState;
    draggedItem: IDraggedItem | null;
    exportAreaStyle: Record<string, any>;
    isExporting: boolean;
    isItemMoved: boolean;
    lineType: {
        label: string;
        value: string;
    }[];
    localList: IOrganizationTreeItem[];
    mouseState: IMouseState;
    parentPointerState: IParentPointerState;
    parentState: IParentState;
    pointState: IPointState;
    selectedConnection: ISelectedConnection | null;
    selectedItem: IDraggedItem | null;
    selectedLineType: any;
}, {
    getMinMaxXY(): {
        maxX: number;
        minX: number;
        maxY: number;
        minY: number;
    };
}, {
    doExport(): Promise<string | null>;
    doParentZoom(inc: number): void;
    doParentZoomRefresh(): void;
    doSetTempConnectionPath(): void;
    doUpdateItemMovedConnections(triggerIndex: number): void;
    doUpdatePointMovedConnection(points: ICoordinates[], connectionIndex: number, itemIndex: number): void;
    getCanvasRect(): any;
    getCoordinatesEnd(ev: MouseEvent | TouchEvent): {
        x: number;
        y: number;
    };
    getCoordinatesMove(ev: MouseEvent | TouchEvent, treshold?: number): ICoordinates;
    getOptionLine(opt: any): string;
    handleChangeItemPoint(item: IOrganizationTreeItem, index: number): void;
    handleChangeLineType(selected: any): void;
    handleClickItem(item: IOrganizationTreeItem, index: number): void;
    handleConnectionDragged(io: string, fromRect: DOMRect): void;
    handleItemChangePosition(coordinates: ICoordinates): void;
    handleItemDragged(item: IDraggedItem): void;
    handleParentClick(ev: MouseEvent | TouchEvent): void;
    handleParentClickOutside(event: MouseEvent): void;
    handleParentDragEnd(ev: MouseEvent | TouchEvent): void;
    handleParentKeydown(ev: KeyboardEvent): Promise<void>;
    handleParentPointerDown(ev: PointerEvent): void;
    handleParentPointerMove(ev: PointerEvent): void;
    handleParentPointerUp(ev: PointerEvent): void;
    handleParentPosition(ev: MouseEvent | TouchEvent): void;
    handleParentZoom(ev: WheelEvent): void;
    handlePointDragged(target: IPointTarget, fromRect: DOMRect): void;
    handleSelectConnection(connection: ISelectedConnection): void;
    isConnectionExist(fromId: string, toId: string): boolean;
    isItemDragged(key: string): boolean;
    isItemSelected(key: string): boolean;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    change: (_list: IOrganizationTreeItem[]) => boolean;
    clickItem: (_item: IOrganizationTreeItem, _index: number) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    isEditable: {
        required: false;
        type: BooleanConstructor;
    };
    list: {
        required: true;
        type: PropType<IOrganizationTreeItem[]>;
    };
}>> & {
    onChange?: ((_list: IOrganizationTreeItem[]) => any) | undefined;
    onClickItem?: ((_item: IOrganizationTreeItem, _index: number) => any) | undefined;
}, {
    isEditable: boolean;
}, {}>;
export default _default;
