import "./stepper.css";
import { defineComponent as I, resolveComponent as B, openBlock as t, createElementBlock as o, mergeProps as k, createElementVNode as n, Fragment as h, renderList as f, normalizeClass as v, createBlock as u, resolveDynamicComponent as m, toDisplayString as i, createCommentVNode as a, renderSlot as g, normalizeProps as N, withCtx as c, createTextVNode as y, createVNode as $, guardReactiveProps as D } from "vue";
import T from "../button/button.js";
import { c as S, p as P, x as E } from "../../icons-ba8254f6.js";
import { _ as F } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
const q = I({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0,
    finish: () => !0
  },
  props: {
    alternateTitle: {
      required: !1,
      type: Boolean
    },
    hideFooter: {
      required: !1,
      type: Boolean
    },
    interceptNav: {
      required: !1,
      type: Function
    },
    isDetail: {
      required: !1,
      type: Boolean
    },
    items: {
      required: !0,
      type: Object
    },
    mobile: {
      required: !1,
      type: Boolean
    },
    modelValue: {
      required: !0,
      type: Number
    },
    nonLinear: {
      required: !1,
      type: Boolean
    },
    type: {
      default: "horizontal",
      type: String
    }
  },
  name: "sb-stepper",
  components: {
    "sb-button": T
  },
  data() {
    return {
      isButtonDisabled: !1,
      localCurrent: 1,
      localItems: []
    };
  },
  computed: {
    getNextColor() {
      return this.localItems[this.localCurrent - 1].nextColor || "secondary";
    },
    getNextText() {
      return this.localItems[this.localCurrent - 1].nextText || "next";
    },
    getPrevColor() {
      return this.localItems[this.localCurrent - 1].prevColor || "secondary";
    },
    getPrevText() {
      return this.localItems[this.localCurrent - 1].prevText || "prev";
    },
    getSkipText() {
      return this.localItems[this.localCurrent - 1].optionalText || "skip";
    },
    iconCheck() {
      return S();
    },
    iconPen() {
      return P();
    },
    iconXMark() {
      return E();
    },
    isNextDisabled() {
      return this.isError(
        this.localItems[this.localCurrent - 1].rules
      ) || this.isButtonDisabled;
    }
  },
  methods: {
    doNavigate(e) {
      this.localCurrent + e <= this.items.length ? (this.$emit("update:modelValue", this.localCurrent + e), this.$emit("change", this.localCurrent + e)) : this.localCurrent === this.items.length && this.$emit("finish");
    },
    async handleClickHead(e) {
      return await this.handleNav(e + 1 - this.localCurrent);
    },
    async handleNav(e, l = !1) {
      if (l)
        this.localItems[this.localCurrent - 1].isSkip = !0, this.doNavigate(e);
      else {
        const d = this.localCurrent + e;
        if (this.localItems[d - 1] && this.localItems[d - 1].optional && this.localItems[d - 1].isSkip && (this.localItems[d - 1].isSkip = !1), this.interceptNav) {
          this.isButtonDisabled = !0;
          const b = await this.interceptNav(
            this.localCurrent + e
          );
          this.isButtonDisabled = !1, b && this.doNavigate(e);
        } else
          this.doNavigate(e);
      }
    },
    isError(e) {
      return e ? e.some(
        (d) => !d()
      ) : !1;
    },
    isFilled(e) {
      return this.localCurrent > e + 1;
    }
  },
  watch: {
    items: {
      deep: !0,
      handler(e) {
        this.localItems = [...e];
      },
      immediate: !0
    },
    modelValue: {
      handler(e) {
        this.localCurrent = e;
      },
      immediate: !0
    }
  }
});
const w = { class: "stepper-header" }, V = ["onClick"], z = { class: "header-step-number-wrapper" }, L = { key: 3 }, M = { key: 1 }, H = { key: 0 }, O = { class: "stepper-body" }, X = { class: "action-buttons" }, j = { class: "stepper-body" }, R = { class: "action-buttons" };
function A(e, l, d, b, G, J) {
  const p = B("sb-button");
  return t(), o("div", k({
    class: ["stepper-wrapper", [e.type]]
  }, { ...e.$attrs }), [
    n("div", w, [
      (t(!0), o(h, null, f(e.localItems, (s, r) => (t(), o(h, {
        key: `header-step-${r}`
      }, [
        n("div", {
          class: v(["header-step", {
            "non-linear": e.nonLinear || e.isDetail,
            active: e.localCurrent >= r + 1 && !s.isSkip,
            alternate: e.alternateTitle,
            error: e.isError(s.rules),
            filled: e.isFilled(r)
          }]),
          onClick: () => (e.nonLinear || e.isDetail) && e.handleClickHead(r)
        }, [
          n("div", z, [
            e.isDetail ? (t(), o("span", M, i(r + 1), 1)) : (t(), o(h, { key: 0 }, [
              e.isError(s.rules) ? (t(), u(m(e.iconXMark), { key: 0 })) : e.localCurrent === r + 1 && !s.isSkip ? (t(), u(m(e.iconPen), { key: 1 })) : e.isFilled(r) && !s.isSkip ? (t(), u(m(e.iconCheck), { key: 2 })) : (t(), o("span", L, i(r + 1), 1))
            ], 64))
          ]),
          e.mobile ? a("", !0) : (t(), o("div", {
            key: 0,
            class: v([{
              error: e.isError(s.rules)
            }, "header-step-label-wrapper"])
          }, [
            n("div", null, i(s.title), 1),
            s.subtitle ? (t(), o("div", H, i(s.subtitle), 1)) : a("", !0)
          ], 2)),
          e.type === "vertical" ? (t(), o("div", {
            key: 1,
            class: v(["content-wrapper", {
              expanded: e.localCurrent === r + 1
            }])
          }, [
            n("div", O, [
              n("div", {
                class: "stepper-body-content",
                ref_for: !0,
                ref: `body-content-${r + 1}`
              }, [
                e.localCurrent === r + 1 ? g(e.$slots, "step", N(k({ key: 0 }, {
                  ...s,
                  index: r + 1
                })), void 0, !0) : a("", !0)
              ], 512)
            ]),
            e.hideFooter ? a("", !0) : (t(), o("div", {
              key: 0,
              class: v(["stepper-footer", { "only-next": e.localCurrent === 1 }])
            }, [
              r !== 0 ? (t(), u(p, {
                key: 0,
                color: e.getPrevColor,
                disabled: e.isButtonDisabled,
                "no-elevation": "",
                type: "button",
                variant: "outlined",
                onClick: l[0] || (l[0] = (C) => e.handleNav(-1))
              }, {
                default: c(() => [
                  y(i(e.getPrevText), 1)
                ]),
                _: 1
              }, 8, ["color", "disabled"])) : a("", !0),
              n("div", X, [
                e.localItems[e.localCurrent - 1].optional ? (t(), u(p, {
                  key: 0,
                  disabled: e.isButtonDisabled,
                  "no-elevation": "",
                  color: "secondary",
                  type: "button",
                  variant: "outlined",
                  onClick: l[1] || (l[1] = (C) => e.handleNav(1, !0))
                }, {
                  default: c(() => [
                    y(i(e.getSkipText), 1)
                  ]),
                  _: 1
                }, 8, ["disabled"])) : a("", !0),
                $(p, {
                  type: "button",
                  color: e.getNextColor,
                  disabled: e.isNextDisabled,
                  onClick: l[2] || (l[2] = (C) => e.handleNav(1))
                }, {
                  default: c(() => [
                    y(i(e.getNextText), 1)
                  ]),
                  _: 1
                }, 8, ["color", "disabled"])
              ])
            ], 2))
          ], 2)) : a("", !0)
        ], 10, V),
        r !== e.localItems.length - 1 && e.type !== "vertical" ? (t(), o("hr", {
          key: 0,
          class: v(["header-step_divider", {
            active: e.isFilled(r),
            mobile: e.mobile
          }])
        }, null, 2)) : a("", !0)
      ], 64))), 128))
    ]),
    e.type === "horizontal" ? (t(), o(h, { key: 0 }, [
      n("div", j, [
        (t(!0), o(h, null, f(e.localItems, (s, r) => (t(), o(h, {
          key: `body-content-${r}`
        }, [
          e.localCurrent === r + 1 ? (t(), o("div", {
            key: 0,
            ref_for: !0,
            ref: `body-content-${r + 1}`,
            class: "stepper-body-content"
          }, [
            g(e.$slots, "step", N(D({
              ...s,
              index: r + 1
            })), void 0, !0)
          ], 512)) : a("", !0)
        ], 64))), 128))
      ]),
      e.hideFooter ? a("", !0) : (t(), o("div", {
        key: 0,
        class: v(["stepper-footer", { "only-next": e.localCurrent === 1 }])
      }, [
        e.localCurrent !== 1 ? (t(), u(p, {
          key: 0,
          color: e.getPrevColor,
          disabled: e.isButtonDisabled,
          "no-elevation": "",
          type: "button",
          variant: "outlined",
          onClick: l[3] || (l[3] = (s) => e.handleNav(-1))
        }, {
          default: c(() => [
            y(i(e.getPrevText), 1)
          ]),
          _: 1
        }, 8, ["color", "disabled"])) : a("", !0),
        n("div", R, [
          e.localItems[e.localCurrent - 1].optional ? (t(), u(p, {
            key: 0,
            disabled: e.isButtonDisabled,
            "no-elevation": "",
            color: "secondary",
            type: "button",
            variant: "outlined",
            onClick: l[4] || (l[4] = (s) => e.handleNav(1, !0))
          }, {
            default: c(() => [
              y(i(e.getSkipText), 1)
            ]),
            _: 1
          }, 8, ["disabled"])) : a("", !0),
          $(p, {
            type: "button",
            color: e.getNextColor,
            disabled: e.isNextDisabled,
            onClick: l[5] || (l[5] = (s) => e.handleNav(1))
          }, {
            default: c(() => [
              y(i(e.getNextText), 1)
            ]),
            _: 1
          }, 8, ["color", "disabled"])
        ])
      ], 2))
    ], 64)) : a("", !0)
  ], 16);
}
const Z = /* @__PURE__ */ F(q, [["render", A], ["__scopeId", "data-v-feee9646"]]);
export {
  Z as default
};
